<?php		

	/**
	 *	Show logfile entries
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	

	require "inc/includer.inc.php";
	require_once("inc/admin.inc.php");
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLADMINLOGVIEW);
	include "inc/header.inc.php";
	
	
	$strResultTable = "";
	$strMessage = "";
	$bError = FALSE;

	define("RESULT_0050",1);
	define("RESULT_0100",2);
	define("RESULT_0250",3);
	define("RESULT_0500",4);
	define("RESULT_1000",5);
	
	$arrResults = array(	RESULT_0050		=> "50 ".LANG_INPLOGVIEWRESULT,
							RESULT_0100		=> "100 ".LANG_INPLOGVIEWRESULT,
							RESULT_0250		=> "250 ".LANG_INPLOGVIEWRESULT,
							RESULT_0500		=> "500 ".LANG_INPLOGVIEWRESULT,
							RESULT_1000		=> "1000 ".LANG_INPLOGVIEWRESULT		);
											
	
	//
	// Securitycheck
	//
	if(!isset($_SESSION['admin']) || 
		md5("This_user_is_an_admin_from".$_SERVER['REMOTE_ADDR'])!=$_SESSION['admin'])	{
		
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	
	//
	// Process form
	//
	if(isset($_POST['ready']) && strtoupper($_POST['ready'])=="YES")	{

		switch(TRUE)	{

			case isset($_POST['f_deletelog']):
				
				// Delete log entries
				$DelRows=DeleteActionsFromDB($_POST['f_actiontype']);
				$strMessage = ParseIn(LANG_INPLOGVIEWDELETEDROWS,sprintf("%d",$DelRows));
				
				break;
			case isset($_POST['f_showlog']):
			
				// Show log entries
				$Limit = 500;
				switch($_POST['f_maxresults'])	{
					case RESULT_0050:
						$Limit = 50; break;
					case RESULT_0100:
						$Limit = 100; break;
					case RESULT_0250:
						$Limit = 250; break;
					case RESULT_1000:
						$Limit = 1000; break;
				}
				
				// Read entries				
				$data = GetActionsFromDB($_POST['f_actiontype'], $Limit);
				if(!is_array($data))	{
					$bError = TRUE;
					$strMessage = LANG_LOGFILEEMPTY;
				} else {

					$strResultTable = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">".
						"<tr>".
						"<th>Actiontype</th>".
						"<th>User-ID</th>".
						"<th>Text</th>".
						"<th>Time</th>".
						"</tr>";
					
					$i=0;
					
					foreach($data as $element)		{
						$strResultTable.= "<tr class=\"".($i%2==0?"highlighted":"nonhighlighted")."\">".
							"<td>".$element['actiontype']."</td>".	
		  					"<td>".$element['actionuserid']."</td>".
		  					"<td>".$element['actiontext']."</td>".
		  					"<td>".FormatDate($element['actiontime'],"",false)."</td></tr>";
	  				
	  					$i++;
	  				}
	  				$strResultTable.= "</table>";
				}
				break;
		}
	} else {
		$_POST['f_maxresults'] = RESULT_0500;
	}

	
	//
	// Display template
	//
	$OptionList=GetActionLogOptions($_POST['f_actiontype']);
	$OptionResults = "";
	foreach($arrResults as $key=>$value)	{
		$OptionResults .= "<option value=\"".$key."\"".
			($key==$_POST['f_maxresults']?" selected":"").">".
			$value."</option>";
	}
		
	
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_showlog.tpl.php";	
	include "inc/footer.inc.php";

?>