<?php 			

	//	cts ClassAd Version 4.1
	// 	ClassAd common functions									
	//
	//	Notes: -
	//
	// (c) 2002-2005 cts projects&software, http://www.projects-and-software.de/classad


if (!defined('__COMMON_INC__')) {
    define('__COMMON_INC__', 1);	

    
    /**
     * Get config parameter
     *
     * @param string Configparameter
     * @return mixed
     */
	function GetConfig($strVar)	{
		if(isset($GLOBALS['CONFIG'][strtoupper($strVar)]))	{
			return $GLOBALS['CONFIG'][strtoupper($strVar)];
		} else {
			return "";
		}
	}
    
    
    function GetPageTitle($strName)		{
   		return (GetConfig('PD_WEBURL')."&nbsp;&middot;&nbsp;".$strName);
    }
       
	function GetCategoriesForSelect($CatToSelect=-1,$AgeRestricted=false,$AddDummy=false)	{
		
		$RetVal = "";
		
		// Open Database
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			$RetVal = "--- ERROR ---";
			return $RetVal;
		}

		// Read Categories
		$sql = "SELECT catid,catname,catagerestricted ".
			"FROM cf_categories ".
			"WHERE ISNULL(catprev) ".
			"ORDER BY catname";
		$data = $DB->dbselect($sql);

		if($data==false)	{
			// Keine Daten oder fehler bei der Konnektierung!
			$RetVal = "--- NO CATEGORIES FOUND ---";
			//$DB->close();
			return $RetVal;	
		}
	
		// Build dummy
		if($AddDummy)	{ $RetVal = "<option value=\"-1\" ".($CatToSelect==(-1)?"selected":"").">-------</option>"; }

		// Show categories
		foreach($data as $element)	{
			if($AgeRestricted==true && $element['catagerestricted']=="1")	{ 
				;	
			} else {
				$RetVal .= "<option value=\"".$element['catid']."\"".
					($element['catid']==$CatToSelect?" selected":"").">".
					$element['catname']."</option>";							
			}
		}
		
		return $RetVal;

	}

	
	function GetCategorieByID($ID = -1)		{
	
		// No input, no output ;-)
		if(is_int($ID)==false && is_string($ID)==false)	{
			return "";				// Parameter Error (no integer or string)
		}
		
		if(($ID <= 0))	{
			return 	"";				// Parameter Error (wrong value)
		}
		
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return "";				// DB Error
		}
		
		// Read Categories
		$sql = "SELECT catid,catname,catagerestricted,caticonlink,catprev,catdesc from cf_categories WHERE catid = '".$ID."'";
		$data = $DB->dbselect($sql);
		
		if(!is_array($data) || sizeof($data)==0)	{
			$CatArray= array(	"catname"=>"???", "catagerest"=>"", "caticonlink"=>"",
				"catid"=>-1, "catdesc"=>"???"); 			
		} else {
			// Show categories
			foreach($data as $element)
			{
				$CatArray = array ( 'catname' 		=> $element['catname'],
									'catagerest'	=> $element['catagerestricted'],
									'caticonlink'	=> $element['caticonlink'],
									'catprev'		=> $element['catprev'],
									'catid'			=> $element['catid'],
									'catdesc'		=> $element['catdesc']	);
			}
		}
		return $CatArray;
	}
	

	function RedirectTo($pathInfo="")		{
		
		$port    = !preg_match("/^(80|443)$/",getenv("SERVER_PORT"),$portMatch)
                   ? ":".getenv("SERVER_PORT")
                   : "";
                                         
        // Redirect    
        header("Location: "
               .(($portMatch[1] == 443) ? "https://" : "http://")
               .getenv("SERVER_NAME").$port."/".GetConfig('PD_SCRIPTPATH').$pathInfo);
        exit;	
	}
	
	
	function DaysBetweenDates($DateFirst="",$DateLast="")	{
		// Calculates Time between two MYSQL-Dates
		// ATT: Easy calculation not very precise
		
		if(empty($DateFirst))	{ return 0; }
		if(empty($DateLast))	{ $DateLast=date("Y-n-j"); }
				
		list($yearFirst, $monthFirst, $dayFirst) = explode("-", $DateFirst);
		list($yearLast, $monthLast, $dayLast) = explode("-", $DateLast);
		$days = (($yearLast-$yearFirst)*365.25)+(($monthLast-$monthFirst)*30.4)+($dayLast-$dayFirst);
		
		return (sprintf("%d",$days*(-1)));
	}
	
	
	///////////////
	// function   :		GetAvailLang($ForOptionField=false,$SelectedLang="")
	//					returns all available languages as clear text or for use in an option list
	//
	// parameters :		$number_of_cats				Formatted for use in an option list
	// 
	// return     :		array or string (<option>[...]</option>					
	///////////////

	function GetAvailLang($bForOptionField=false,$strSelectedLang="")		{
		
		if(!$bForOptionField)	{
			return $GLOBALS['DEFINEDLANGUAGES'];
		}
		
		$strRetVal = "";
	
		// Build options
		if(is_array($GLOBALS['DEFINEDLANGUAGES']))	{
			foreach($GLOBALS['DEFINEDLANGUAGES'] as $key=>$value) 	{
				$strRetVal.= "<option value=\"".$key."\"".
					(strtoupper($key)==strtoupper($strSelectedLang)?" selected":"").">".
					$value."</option>";
			}
		}
		return $strRetVal;
	}
		
	
	function GetArticleByID($IDIn=-1,$Secure=false)		{
		// No input, no output ;-)
		if(is_int($IDIn)==false && is_string($IDIn)==false)	{
			return false;								// Parameter Error (no integer or string)
		}
		
		if(($IDIn <= 0))	{ return false;	}
		
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// DB Error
		}
		
		// Build sql string
		$sql = "SELECT cf_ads.*, cf_categories.catname ".
			"FROM cf_ads ".
			"LEFT OUTER JOIN cf_categories on cf_ads.adcat=cf_categories.catid ".
			"WHERE adid=".$IDIn." LIMIT 1";
		
		// Read database
		$data = $DB->dbselect($sql);
		if(!is_array($data) || sizeof($data)==0 )	{
			return FALSE;				// Not Found
		} else {
			return $data;
		}
	}
	
	function ShowErrorMessage($Message = "",$ReturnLink="")	{
		// Displays an errormessage
		if($Message=="")	{
			$Message = "Unspecified error occured!";
		}
		include "templates/".$GLOBALS['ACTIVELANGUAGE']."/error.tpl.php";
	}

	function BuildMessagelistForListField($CatIn="",$OutDated=false,$FilterWord="")		{
		$Filter = "";
		
		// Build filter
		if((is_int($CatIn)==false && is_string($CatIn)==false) || empty($CatIn))	{
			$Filter="";				// Parameter Error (no integer or string)
		} else {	
			$Filter=" WHERE adcat='".$CatIn."'";
		}
		
		// Check, if only outdated Message should be shown
		if($OutDated)	{
			$nowdate = date("Y.m.d H:i:s");
			if(!empty($Filter))	{
				$Filter .= " AND ";	
			} else {
				$Filter = " WHERE ";
			}
			$Filter.= "(adoutdate < '".$nowdate."')";
		}
		
		// Is there a filterword
		if(!empty($FilterWord))	{
			if(!empty($Filter))	{
				$Filter.= " AND ";
			} else {
				$Filter = " WHERE ";
			}	
			$phrase = explode(" ",$FilterWord);
			
			$WhereClause = "";
			for($i=0;$i<count($phrase);$i++)		{
				$WhereClause .= "(adtitle LIKE '%".$phrase[$i]."%' OR ";
				$WhereClause .= "adid LIKE '%".$phrase[$i]."%' OR ";
				$WhereClause .= "adname LIKE '%".$phrase[$i]."%') ";
		
				// Be secure, that the last array doesnt get an Connectorelement (AND,OR)
				if($i < (count($phrase)-1))	{
					$WhereClause .= " AND ";
				}
			}
			$Filter.= $WhereClause;
		}
	
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		// Read Messages
		$sql = "SELECT adid, adtitle, adpiclink, adagerestricted, adfeatured, adchecked from cf_ads".$Filter." ORDER BY adid";
		$data = $DB->dbselect($sql);

		if($data===false)	{ return false;	}
		
		$RetVal = "";
		// Show categories
		foreach($data as $element)
		{
			$PicMark = "";
			if(!empty($element['adpiclink']))	{ $PicMark = " !* PIC *!"; }
			$ReleaseMark="";
			if($element['adchecked']!=1)	{ $ReleaseMark = "*! REL !* "; }
			$FeaturedMark = ($element['adfeatured']?" *! FEAT !*":"");
			
			// build options
			$RetVal.= "<option value=\"".$element['adid']."\">ID:".$element['adid']." - ".
				$ReleaseMark.$element['adtitle'].($element['adagerestricted']=="1" ? " (*18*)" : "").
				$PicMark.$FeaturedMark."</option>";	
		}
		
		return $RetVal;
	}
	
	function BuildUserlistForListField($Filterword="")		{
			
		if(empty($Filterword))	{ $Filter =""; } else 
		{
			// Build filter
			$Filter = " WHERE username LIKE '%".$Filterword."%' OR userrealname LIKE '%".$Filterword."%' ".
			"OR usercity LIKE '%".$Filterword."%' OR userzip LIKE '%".$Filterword."%' ".
			"OR useremail LIKE '%".$Filterword."%'";
		}
						
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		// Read Messages
		$sql = "SELECT userid,username,userrealname,usercity,userblocked,useragechecked,userrights ".
			"FROM cf_users".$Filter." ".
			"ORDER BY userid";
		$data = $DB->dbselect($sql);

		if($data===false)	{
			return false;				// Database error
		}
		
		$RetVal = "";
		// Show categories
		foreach($data as $element)
		{
			// Build options
			$RetVal.= "<option value=\"".$element['userid']."\" style=\"\">".
				"ID:".$element['userid']." - ".
				$element['username'].
				($element['userblocked']==1?" *BLOCKED* ":"").
				($element['useragechecked']==1?" *18* ":"").
				($element['userrights'] & 2?" *AUTH* ":"").
				" (".$element['userrealname']." - ".$element['usercity'].")".
				"</option>";	
		}
		return $RetVal;
	}

	function GetAdTypes($strLang="GER")	{
		return array(	AD_TYPE_OFFERING	=> LANG_ADTYPEMISC,
						AD_TYPE_SEARCHING	=> LANG_ADTYPEOFFERING,
						AD_TYPE_MISC 		=> LANG_ADTYPESEARCHING	);
	}
		
	function GetAdTypesForDropDown($iSelected=-1,$bDummy=TRUE, $bAllDummy=FALSE)	{
		
		$arrAdTypes = GetAdTypes();
		$strOptions = "";

		if($bDummy)		{
			$strOptions.= "<option value=\"-1\"".
				($iSelected==(-1)?" selected":"").">".
				($bAllDummy?LANG_FILTERALLTYPES:"----")."</option>";
		}
				
		foreach($arrAdTypes as $key=>$value)	{
			$strOptions.= "<option value=\"".$key."\"".
				($iSelected==$key?" selected":"").">".
				$value."</option>";
		}
		return $strOptions;								
	}

	function DecodeAdType($iType)	{
		$arrAdTypes = GetAdTypes();
		return (array_key_exists($iType,$arrAdTypes)?$arrAdTypes[$iType]:"???");
	}
	
	function BuildCategorielistForListField($SelectedCat="",$AgeControlled=false)		{
		
		// Query database
		$DB = new SQLDatabase(); 
		$DB->dbconnect();
		if($DB==false)	{ return false;	}
		
		// Read Messages
		$sql = "SELECT catid,catname,catdesc,catagerestricted from cf_categories ORDER BY catid";
		$data = $DB->dbselect($sql);

		if($data===false)	{ return false;	}

		$RetVal = "";
		// Show categories
		foreach($data as $element)
		{
			if($AgeControlled==true && $element['catagerestricted']=="1")	{ $RetVal.=""; }
			else {
				
				if($SelectedCat==$element['catid'])	{ 
					$Selected=" selected"; 
				} else {
					$Selected = "";	
				}
				
				// build options
				$RetVal.= "<option value=\"".$element['catid']."\"".$Selected.">ID:".$element['catid'];
				$RetVal.= "- ".$element['catname']." ".($element['catagerestricted']=="1" ? "(*18*) " : "");
				$RetVal.= "(".$element['catdesc'].")</option>";	
			}
		}
		
		return $RetVal;
	}
	
	function DeleteMessage($IDIn=-1,$Admin=true)		{
		if($Admin)	{
			return(DeleteArticle($IDIn,true,"","",-99));
		} else {
			return(DeleteArticle($IDIn,true));
		}	
	}
	
	function DeleteArticle($iAdId=-1,$bDeletePics=false,$strPicName="",$iUserId=-1)		{
		// deletes articles and attached pictures
		// No input, no output
		if((integer)$iAdId<=0)		{
			return FALSE;
		}
		
		// Connect database
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{ return FALSE; }

		if((integer)$iUserId>0)	{
			// Securitycheck necessary
			$data = $DB->dbselect("SELECT aduserid FROM cf_ads WHERE adid=".$iAdId);
			if(is_array($data) && sizeof($data)>0)		{
				if($iUserId!=$data[0]['aduserid'])	{	
					return FALSE;			
				}
			} else {
				return FALSE;
			}
		} 

		// DB delete / Article delete
		$sql = "DELETE from cf_ads WHERE adid='".$iAdId."'";
		$iRetVal = $DB->dbdelete($sql);

		// Delete free fields - no proof, if really deleted 
		$sql = "DELETE from cf_adfreerows WHERE adid='".$iAdId."'";
		$DB->dbdelete($sql);
		
		if($bDeletePics)	{
			require_once("inc/picture.class.php");
			require_once("inc/picturelist.class.php");
			
			$oPicList = new PictureList();
			$oPicList->ReadList($iAdId);
			$oPicList->Delete();
		}
		
		// Log every use of this function			
		LogActions("MSGD","Message-ID ".$iAdId." - IP: ".
			$_SERVER['REMOTE_ADDR'],($iUserId <=0 ? 0 : $iUserId));	
		return $iRetVal;
	}
		
	function DeleteArrayOfMessage($DelArray="",$UID=-1)		{
		// Secure delete of all given messages
		// MUST HAVE a valid user-ID
		
		if(!is_array($DelArray) || $UID<=0 )	{ return false; }
		$Good=0; $Bad=0;
		
		foreach($DelArray as $DelMsg)	{
			if(GetConfig('DEBUG')) 	{ echo "Deleting message: ".$DelMsg."<br>"; }
			if(DeleteArticle($DelMsg,true,"",$UID)>0)	{ 
				$Good++; 
			} else { 
				$Bad++; 
			} 
		}
		return array(	"good"	=> sprintf("%d",$Good), 
						"bad"	=> sprintf("%d",$Bad)
		);
	}
	
	function ProlongArrayOfMessage($ProlongArray="")		{
		if(!is_array($ProlongArray) || sizeof($ProlongArray)==0)	{ return false; }
		
		foreach($ProlongArray as $element)	{
			ProlongMessage($element,7);	
		}
		return TRUE;
	}
	
	function ProlongMessage($iMsgId, $iDays=30)		{
		
		// Open database
		$DB = new SQLDatabase(); 
		$DB->dbconnect();
		if($DB==false)	{ return false;	}
		
		$sql = "UPDATE cf_ads set adoutdate=DATE_ADD(adoutdate,INTERVAL ".$iDays." DAY) ".
			"WHERE adid='".$iMsgId."'";
		$DB->dbupdate($sql);
		
		return TRUE;
	}
	
		
	
	///////////////
	// function   :		LogActions
	//					logs important user/script action to database
	//
	// parameters :		$ActionType				Specifies a type of action
	// 					$ActionText				Additional text to describe the action
	//					$ActionUserID			Additional user id of acting user
	//
	// $ActionType:		SRCP					Search performed
	//					LOG						Successful login performed
	//					FLDLOG					Failed login
	//					USRA					User added
	//					USRE
	//					USRD					User deleted
	//					MSGA					Message added
	//					MSGD					Message deleted
	//					... more to follow ...
	///////////////
	
	function LogActions($ActionType="",$ActionText="",$ActionUserID=0)		{
		
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
				
		// Build querystring
		$actiondate = date("Y.m.d H:i:s");
		$sql = "INSERT INTO cf_actions ";
		$sql.= "(actiontype,actionuserid,actiontext,actiontime) ";
		$sql.= "values ('$ActionType','$ActionUserID','$ActionText','$actiondate')";

		// Add to database
		$RetVal = $DB->dbinsert($sql);
		
		return $RetVal;
	}
	
	///////////////
	// function   :		GetArticlesPerCat($catid=-1,$viewsum=false,$corrected=false)
	//					return the number of articles in a specified category
	//					and the number of views per category
	//
	// parameters :		$catid					Category id
	//									def.:	false, number of all articles in database
	// 
	// return     :		return article amount or -1 on an error	
	//					in case of view aggregation an array is returned				
	///////////////
	function GetArticlesPerCat($catid=-1,$viewsum=false,$RelCorrected=false,$AgeCorrected=false,$iAdTypes=-1)		{

		if((integer)$catid<=0)		{
			return -1;
		}
		
		$sql = "SELECT COUNT(*) as Amount, SUM(adviewed) as ViewSum ".
			"FROM cf_ads ".
			"WHERE cf_ads.adcat=".$catid." ".
			($AgeCorrected?"AND adagerestricted=0 ":"").
			($RelCorrected?"AND adchecked=1 ":"");

		if($iAdTypes != (-1))	{
			$sql.= "AND adtype=".$iAdTypes." ";
		}	
			
		// Open database
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			return -1;
		}
		
		// Query database
		$data = $DB->dbselect($sql);	
		if(!is_array($data))	{
			return -1;				// Database error
		}
		
		if($viewsum)	{
			return array(	'amount' 	=> $data[0]['Amount'],
							'sumviews'	=> $data[0]['ViewSum']	);
		} else {
			return $data[0]['Amount'];
		}
	}

	// Wrapper
	function GetCorrectedArticlesPerCat($CatID,$AgeRestricted=true,$iAdTypes=-1)	{
		return GetArticlesPerCat($CatID,false,true,$AgeRestricted, $iAdTypes);
	}


	///////////////
	// function   :		GetArticlesInDB()
	//					returns total number of articles in database
	//
	// parameters :		
	//
	// return     :		return article amount or -1 on an error					
	///////////////
	
	function GetArticlesInDB()		{
		
		// Open database
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			return -1;
		}
		
		$sql = "SELECT COUNT(*) as Amount FROM cf_ads";
		$data = $DB->dbselect($sql);
		
		if(!is_array($data) || sizeof($data)==0)	{
			return 0;
		} else {
			return ($data[0]['Amount']);
		}
	}	
	
	///////////////
	// function   :		BuildCatMover($NumberOfCats)
	//					return a selector for different pages of article listings
	//
	// parameters :		$number_of_cats				Counted number of articles per cat
	//					$ArtPerPage					Number of articles per Page
	//					$Page						Actually shown page
	// 
	// return     :		string or empty string, in case of an error					
	///////////////
	
	function BuildCatMover($NumberOfCats,$ArtPerPage,$CatID,$Page,$Delta=5)		{
		
		$PrevPage = LANG_LINKTOPREVPAGE;
		$NextPage = LANG_LINKTONEXTPAGE;
		
		if(GetConfig('DEBUG'))	{
			echo "Number of Cats: ".$NumberOfCats."<br>";
			echo "Art per Page: ".$ArtPerPage."<br>";
			echo "CatID: ".$CatID."<br>";
			echo "Page: ".$Page."<br>";
		}
		
		if($NumberOfCats <0 || $ArtPerPage <=0)	{
			// false input
			return "";
		}
		if($NumberOfCats == 0)	{
			// tribute to mathematics ;-)
			$Pages = 1;	
		} else	{
			// Calculate number of pages and decide what to do... ;-) 
			$Pages=ceil($NumberOfCats/$ArtPerPage);
		}
		
		$RetVal = "";
		switch($Pages)	{
			case 1:  
				// Only one page, no menu needed
				// just show a pseudo link
				$RetVal = $PrevPage."&nbsp;[1]&nbsp;".$NextPage;		
				break;
				
			case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10:
			
				// 2 - 10 pages, standardmenu
				if($Page >= 2)		{
					$RetVal .= "<a href=\"showads.php?catid=".$CatID."&page=".($Page-1)."\">".$PrevPage."</a>&nbsp;";       
				}else{
					$RetVal.=$PrevPage;
				}
				
				for($i=1; $i<=$Pages; $i++)		{
					if($Page==$i)	{
						$RetVal.= "[".$i."]&nbsp;";
					} else {
						$RetVal.= "<a href=\"showads.php?catid=".$CatID."&page=".$i."\">[".$i."]</a>&nbsp;";
					}
				}
				if($Page < $Pages)	{
					$RetVal.= "<a href=\"showads.php?catid=".$CatID."&page=".($Page+1)."\">".$NextPage."</a>";
				}else{$RetVal.=$NextPage;}
				break; 			
				
			default:
				// Special menu with ... for anything bigger than 10 pages
				// Prefix
				if($Page >= 2)		{
					$RetVal .= "<a href=\"showads.php?catid=".$CatID."&page=".($Page-1)."\">".$PrevPage."</a>";       
				}else{$RetVal.=$PrevPage;}
				if($Page <> 1)		{
					$RetVal.= "<a href=\"showads.php?catid=".$CatID."&page=1\">[1]</a>";
				} else {$RetVal.= "[1]";}
								
				// middle part
				if($Page<$Delta)	{$start=2;	}
				else {$start = ($Page-$Delta);}
										
				if($Page>($Pages-$Delta))	{ $end=($Pages-1);			}
				else {$end = $Page+$Delta;}
				echo $end;
				
				for($i=$start; $i<=$end; $i++)		{
					if($Page==$i)	{$RetVal.= "[".$i."]";}
					else {
						$RetVal.= "<a href=\"showads.php?catid=".$CatID."&page=".$i."\">[".$i."]</a>";
					}
				}
				
				// Appendix
				if($Page <> $Pages)	{
					$RetVal.= "<a href=\"showads.php?catid=".$CatID."&page=".$Pages."\">[".$Pages."]</a>";
				} else { $RetVal.= "[".$Pages."]" ;}
				if($Page < $Pages)	{
					$RetVal.= "	<a href=\"showads.php?catid=".$CatID."&page=".($Page+1)."\">".$NextPage."</a>";
				}else{$RetVal.=$NextPage;}
			
				break;
					
		}
		return $RetVal;
	}
	
	function ParseIn($strText="", $strVar1="", $strVar2="")		{
		$strText = preg_replace("(\\%1)",$strVar1,$strText);
		if($strVar2!="")	{	
			$strText = preg_replace("(\\%2)",$strVar2,$strText);
		}
		return $strText;
	}

	
	function GetCorrectedLastPerCat($catid,$AgeCorrected=true)		{
		return GetLatestArticlesPerCat($catid,true,$AgeCorrected);
	}


	///////////////
	// function   :		GetLatestArticlesPerCat($catid=false)
	//					return the date of the latest ad entry per cat
	//
	// parameters :		$catid					Category id
	//									def.:	false, number of all articles in database
	// 
	// return     :		return article amount or -1 on an error					
	///////////////
	
	function GetLatestArticlesPerCat($catid=-1,$RelCorrected=false,$AgeCorrected=false)		{

		if($catid<=0)		{
			return -1;
		}	
		
		$sql = "SELECT IF(!ISNULL(MAX(adindate)),MAX(adindate),DATE('2000-01-01')) as inputdate ".
			"FROM cf_ads ".
			"WHERE adcat=".$catid." ".
			($RelCorrected?"AND adchecked=1 ":"").
			($AgeCorrected?"AND adagerestricted=0 ":"");
				
		// Open database
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			return -1;				// Database error
		}
		$data = $DB->dbselect($sql);	

		if(!is_array($data))	{		
			return -1;		
		} else {
			return $data[0]['inputdate'];
		}
	}
	
	
	function GetCategoryCounts($bCorrReleased=FALSE,$bCorrAgeRestricted=FALSE)	{
		
		$sql = "SELECT adcat, max(adindate) as LastIn, ".
			"COUNT(*) as Counter ".
			"FROM cf_ads ".
			"WHERE 1=1 ".
			($bCorrReleased?"AND adchecked=1 ":"").
			($bCorrAgeRestricted?"AND adagerestricted=0 ":"").
			"GROUP BY adcat";
				
		// Open database
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			return -1;				// Database error
		}
		$data = $DB->dbselect($sql);	

		$arrReturn = array();
		foreach($data as $element)	{
			$arrReturn[$element['adcat']] = array(	"LASTIN"	=>	$element['LastIn'],
													"COUNT"		=>	$element['Counter']		);
		}
		return $arrReturn;
	}
	
	
	///////////////
	// function   :		AddCouter($artid=-1,$Countertype=-1,$amount=1)
	//					Add a view to article views
	//
	// parameters :		$artid					Article ID
	//									def.:	false, number of all articles in database
	// 					$amount					Amount of article views to add (def.: 1)
	//					$Countertype			1 = Ad views, 2 = Ad contacts, 3 = Ad tell
	//				
	// return     :		returns true or false in case of an error					
	///////////////
	
	function AddCounter($artid=-1, $Countertype=-1, $amount=1)		{
		
		// Check parameters
		if(($artid <= 0 && $artid<>false) || ($Countertype > 3 && $Coutertype <= 0))		{
			return false;
		}	
		if(($amount<=0) || ((is_int($amount)==false) && (is_string($amount)==false)))		{
			// Do not execute query if no change of views
			return false;	
		}
				
		// Build SQL string
		switch($Countertype)	{
			case 1:
				$sql = "UPDATE cf_ads SET adviewed=adviewed+".$amount." WHERE adid='".$artid."'";	
				break;
			case 2:
				$sql = "UPDATE cf_ads SET adcontcounter=adcontcounter+".$amount." WHERE adid='".$artid."'";
				break;
			case 3:
				$sql = "UPDATE cf_ads SET adtellcounter=adtellcounter+".$amount." WHERE adid='".$artid."'";	
				break;
			default: 
				return false;
		}					
				
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;			// Database error
		}
		$result = $DB->dbupdate($sql);	
		return true;				// Its not *real* correct to return true in every case
									// but its also not a *real* problem if one view is not counted :-)
	}



	///////////////
	// function   :		GetUserID(String $Username, String $Password)
	//					Checks username and password
	//
	// parameters :		-		
	//
	// return     :		Returns UserId or false if username/password false
	//					Special retcodes: 		-1			User not found
	//											-2			User/Password incorrect
	//											-99			Useraccount blocked					
	///////////////
	
	function GetUserID($strUsername="",$strPassword="")		{
		
		$strUsername = trim($strUsername);
				
		if(empty($strUsername) || empty($strPassword))		{
			return ERR_LOGIN_USER_PASSWORD_MISSING;
		}
		
		// Build SQL-string
		$sql = "SELECT userid, username, userpass, useralterpass, userblocked, userreleased ".
			"FROM cf_users ".
		"WHERE username='".$strUsername."'";
		
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			return ERR_COMMON;			
		}
		$data = $DB->dbselect($sql);
		if(!is_array($data) || sizeof($data)==0)	{
			return ERR_LOGIN_WRONG_PASSWORD;
		}
			
		// Check password
		$element = $data[0];		
		if(strtolower($element['username'])==strtolower($strUsername))	{
			
			// First try, original password
			if($element['userpass']==$strPassword)	{
				if(!empty($element['useralterpass']))	{
					// Login was okay - alternative password found to delete
					$DB->dbupdate("UPDATE cf_users SET useralterpass='', userpasswordset=NULL ".
						"WHERE userid=".$element['userid']);		
				}	
			} elseif($element['useralterpass']==$strPassword)	{
				// User used alternative password to log in, set alternative as
				// regular password
				$DB->dbupdate("UPDATE cf_users SET userpass=useralterpass, userpasswordset=NULL, ".
					"useralterpass='' WHERE userid=".$element['userid']);
			} else {
				// Non of the password was entered correctly
				return ERR_LOGIN_WRONG_PASSWORD;
			}					
					 
			// Test, if useraccount is blocked
			if($element['userblocked']==1)	{
				return ERR_LOGIN_USER_BLOCKED;			
			}
			
			if($element['userreleased']==0)		{
				return ERR_LOGIN_USER_NOT_RELEASED;
			}
			return ($element['userid']);
		} else { 
			return ERR_LOGIN_WRONG_PASSWORD; 
		}
		return $RetVal;
	}
	


	///////////////
	// function   :		GetUserDetails(int intUID)
	//					Gets all user details
	//
	// parameters :		-		
	//
	// return     :		Returns complete userdata in an array or false if the function fails					
	///////////////
	
	function GetUserDetails($intUID = 0,$ReturnRawData=false)		{
		
		if($intUID <= 0)	{ return false;	}
		
		// Build SQL statement
		$sql = "SELECT * FROM cf_users WHERE userid='".$intUID."'";
		
		$DB = new SQLDatabase();
		$DB->dbconnect();
		// Database error
		if($DB==false)	{ return false; }
		$data = $DB->dbselect($sql);
		if($data==false)	{return -1;}
		
		if($ReturnRawData)	{
			// returns rawarray
			return $data;
		} else {
			foreach($data as $element)
			{
				$UserArray = 	array( 		"userid"=>			$element['userid'],
											"username"=>  		$element['username'],
										 	"userrights"=>		$element['userrights'],
										 	"userdeflang"=>		$element['userdeflang'],
										 	"userblocked"=>		$element['userblocked'],
										 	"userreleased"=>	$element['userreleased'],
										 	"userrealname"=>	$element['userrealname'],
										 	"useradress1"=>		$element['useradress1'],
										 	"useradress2"=>		$element['useradress2'],
										 	"usercountry"=>		$element['usercountry'],
										 	"usertitle"=>		$element['usertitle'],
										 	"userhomepage"=>	$element['userhomepage'],
										 	"usericq"=>			$element['usericq'],
										 	"usermsn" =>		$element['usermsn'],
										 	"userskype" =>		$element['userskype'],
										 	"useryahoo"=>		$element['useryahoo'],
										 	"useraim" =>		$element['useraim'],
										 	"userzip"=>			$element['userzip'],
										 	"usercity"=>		$element['usercity'],
										 	"usertel"=>			$element['usertel'],
										 	"useremail"=>		$element['useremail'],
										 	"userfax"=>			$element['userfax'],
										 	"userreleasecode"=> $element['userreleasecode'],
										 	"usermobile"=>		$element['usermobile'],
										 	"userlastsearch"=>	"",
										 	"useragechecked"=>	$element['useragechecked'],
										 	"userlogins"=>		$element['userlogins'],
										 	"useremailhtml"=>	($element['useremailhtml']==1?TRUE:FALSE),
										 	"usercreatedate"=>	$element['usercreatedate'],
										 	"userlastlogin"=>	$element['userlastlogin']
				);		
		
			}
		}
		return $UserArray;
	}

	///////////////
	// function   :		CheckUserName($strUserName="",$strUserEmail="")
	//					Check, if an user is already stored in the database
	//
	// parameters :		-		
	//
	// return     :		returns false, if found or error, or true, if not found					
	///////////////
	
	function CheckUserName($strUserName="",$strUserEmail="")
	{
		if(empty($strUserName) && empty($strUserEmail))		{ return false; }
		$UserNameFound=true;
		$UserEmailFound=true;
	
		// Connect database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		// Database error
		if($DB==false)	{ return false; }
					
		if(!empty($strUserName))	{
			// Build SQL statement
			$sql = "SELECT username FROM cf_users WHERE username='".$strUserName."'";
			$data = $DB->dbselect($sql);
			if($data==false)	{ $UserNameFound = false; }
		}
		if(!empty($strUserEmail))	{
			// Build SQL statement
			$sql = "SELECT userpass FROM cf_users WHERE useremail='".$strUserEmail."'";
			$data = $DB->dbselect($sql);
			if($data==false)	{ $UserEmailFound = false; }
		}
	
		return array( 	"UserNameFound" 	=> $UserNameFound,
						"UserEmailFound"	=> $UserEmailFound );
	}
			
	
	///////////////
	// function   :		UpdateLastLogin($UID=0)
	//					Updates the last time a user logged on and
	//					times logged in
	//
	// parameters :		-		
	//
	// return     :		returns true or false in case of an error					
	///////////////
	
	function UpdateLastLogin($UID=0)		{
		
		if(empty($UID) || $UID <=0)	{ return false;  }
		
		$dtLastLog = date("Y.m.d H:i:s");
		
		// Build SQL statement
		$sql = "UPDATE cf_users SET userlastlogin='".$dtLastLog."', userlogins=userlogins+1 WHERE userid='".$UID."'";
		
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;			// Database error
		}
		$result = $DB->dbupdate($sql);	
		
		return true;
	}
	
	///////////////
	// function   :		AdsSinceDate($Date=0)
	//					
	//
	// parameters :		-		
	//
	// return     :		returns int or false in case of an error					
	///////////////
	
	function AddSinceDate($DateIn="")		{
		
		if(empty($DateIn))	return false;
				
		$sql = "SELECT COUNT(*) AS Anzahl FROM cf_ads WHERE adindate>'".$DateIn."'";
		
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		// Delete Categories
		$data = $DB->dbselect($sql);
		if($data) 	{
			foreach($data as $element)	{
				$RetVal = $element['Anzahl'];
			}
		} else { $RetVal = false; }
		return $RetVal;
	}
	
	///////////////
	// function   :		GetFeaturedArticles($Amount=1,$Rand=true,$ForceAgeRest)
	//					Gets featured ads from database
	//
	// parameters :		$Amount 	Max. Amount of returned ads
	//					$Rand		Should the be random or order date
	//
	// return     :		returns an ad array or false in case of an error					
	///////////////
	function GetFeaturedArticles($Amount=1, $bRand=true, $bSecurity=true)		{
		if($Amount <= 0)		{ return false;	}	
		
		// Build SQL string
		$sql = "SELECT adid,adtitle,adname,adzip,adcity,adpiclink,adindate,adagerestricted,".
			"adviewed, adtype, cf_categories.catagerestricted as catrest ". 
			"FROM cf_ads ".
			"LEFT OUTER JOIN cf_categories ON cf_categories.catid=cf_ads.adcat ".
			"WHERE adchecked=1 AND adfeatured=1 AND ".
			($bSecurity?"(cf_categories.catagerestricted=0 AND adagerestricted=0)":"1=1")." ";
			
		if($bRand)		{
			$sql.= "ORDER BY RAND() LIMIT ".$Amount;	
		} else {
			$sql.= "ORDER BY adindate DESC LIMIT ".$Amount;
		}

		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{ return false; }
		$data = $DB->dbselect($sql);	
		if($data===false)	{ return false;	}
		return $data;
	}
	

	///////////////
	// function   :		GetLatestArticles($Amount=1, $ForceAgeRest)
	//					Gets featured ads from database
	//
	// parameters :		$Amount 	Max. Amount of returned ads
	//					
	// return     :		returns an ad array or false in case of an error					
	///////////////
	function GetLatestArticles($Amount=1, $bSecurity=true)		{
		if($Amount <= 0)		{ return false;	}	
		
		// Build SQL string
		$sql = "SELECT adid,adtitle,adname,adzip,adcity,adpiclink,adindate,adagerestricted,".
			"adviewed, adtype, cf_categories.catagerestricted as catrest ". 
			"FROM cf_ads ".
			"LEFT OUTER JOIN cf_categories ON cf_categories.catid=cf_ads.adcat ".
			"WHERE adchecked=1 AND ".
			($bSecurity?"(cf_categories.catagerestricted=0 AND adagerestricted=0)":"1=1")." ".
			"ORDER BY adindate DESC LIMIT ".$Amount;
			
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{ return false; }
		$data = $DB->dbselect($sql);	
		if($data===false)	{ return false;	}
		return $data;
	}

	
	
	
	///////////////
	// function   :		GetArticlesByUser($UID=-1)    
	//					Get all articles by a special user id
	//
	// parameters :		$UID	 	UserID	
	//
	// return     :		returns an ad array or false in case of an error					
	///////////////
	
	function GetArticlesByUser($UID=-1)		{
		
		if($UID<=0)	{	
			return false;	
		}
		
		// Build SQL string
		$sql = "SELECT adid,adtitle,adpiclink,adindate,adoutdate,adfeatured,".
			"adtellcounter,adcontcounter,adviewed,adchecked,".
			"cf_categories.catid, cf_categories.catname ".
			"FROM cf_ads ".
			"LEFT OUTER JOIN cf_categories ON (cf_categories.catid=cf_ads.adcat) ".
			"WHERE aduserid='".$UID."' ".
			"ORDER BY adindate DESC";
				
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		$data = $DB->dbselect($sql);	
		if($data===false)	{
			return false;				// Database error
		}
		return $data;
	}
		
	
	
	///////////////
	// function   :		GetUserSummary($UID)
	//					return the number of articles posted by an user
	//					incl. responses and views
	//
	// parameters :		$UID			UserID
	//									def.:	false, number of all articles in database
	// 
	// return     :		return array or false in case of an error	
	//									
	///////////////
	
	function GetUserSummary($UID=-1)		{
		
		if($UID<=0)	{ return false; }
		
		$filter = "";
		
		// Build SQL string
		$sql = "SELECT COUNT(*) AS AdSum, SUM(adviewed) as ViewSum, SUM(adfeatured) as FeatSum,";
		$sql.= "SUM(adcontcounter) as ContSum, SUM(adtellcounter) as TellSum FROM cf_ads ";
		$sql.= "WHERE aduserid = ".$UID;		
		
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		$data = $DB->dbselect($sql);	
		if(!is_array($data))	{
			return false;				// Database error
		}
		foreach($data as $element)	{
			$RetVal=array(	"AdSum"		=>$element['AdSum'],
							"ViewSum"	=>$element['ViewSum'],
							"FeatSum"	=>$element['FeatSum'],
							"ContSum"	=>$element['ContSum'],
							"TellSum"	=>$element['TellSum']
			);
		}
		return $RetVal;
	}
	
	
	///////////////
	// function   :		EncodeFreeFieldDefinitions($ArrayInput)
	//					Encodes the freefields definition in one datafield
	//
	// parameters :		$ArrayInput			Array, with formdata
	//					
	// 
	// return     :		returns string with field definition or false in case of error	
	//
	// Definitions:		[FieldIndex];[Use Row (1|0)];[Mandatory (1|0)];[Searchable (1|0)];
	//					[FieldType (1|2|3|4|5|6)];[FieldName];[Description];
	//					[Options1,[Option2,[Option3,...]]]\r\n			
	///////////////
	
	function EncodeFreeFieldDefinitions($ArrayInput="")		{
		if(empty($ArrayInput) || !is_array($ArrayInput))	{ return false; }
		
		$strReturn = "";
		
		foreach($ArrayInput as $FieldRow)	{
			$strReturn .= $FieldRow['findex'].";";
			$strReturn .= $FieldRow['useit']==true ? "1;": "0;"; 
			$strReturn .= $FieldRow['mand']==true ? "1;": "0;";
			$strReturn .= $FieldRow['search']==true ? "1;": "0;";
			
			// switch fieldtypes 
			switch($FieldRow['type'])	{
				case "LIST":
					$strReturn .= "5;";
					break;
				case "OPTION":
					$strReturn .= "2;";
					break;
				case "CHECK":
					$strReturn .= "4;";
					break;
				case "DROPDOWN":
					$strReturn .= "3;";
					break;
				case "TEXTAREA":
					$strReturn .= "6;";
					break;
				default:
					$strReturn .= "1;";
					break;
			}
			
			// string changes
			$strTemp = (string)trim($FieldRow['name']);
			$strTemp =  str_replace(";"," ",$strTemp);
			$strReturn .= $strTemp.";";
			
			$strTemp = (string)trim($FieldRow['description']);
			$strTemp =  str_replace(";"," ",$strTemp);
			$strReturn .= $strTemp.";";
			
			$strTemp = (string)trim($FieldRow['options']);
			$strTemp =  str_replace(";"," ",$strTemp);
			$strReturn .= $strTemp."\r\n";
			
		}
		if(GetConfig('DEBUG')) {
			echo "Encoded FieldDefinitions: ".$strReturn;
		}
		return $strReturn;
	}
	
	///////////////
	// function   :		DecodeFreeFieldDefinitions($strInput)
	//					Decodes the freefields definition from one string
	//
	// parameters :		$strInput			encoded String
	//					
	// 
	// return     :		returns array with field definition or false in case of error	
	//
	// Definitions:		[FieldIndex];[Use Row (1|0)];[Mandatory (1|0)];[Searchable (1|0)];
	//					[FieldType (1|2|3|4|5|6)];[FieldName];[Description];
	//					[Options1,[Option2,[Option3,...]]]\r\n			
	///////////////
	
	function DecodeFreeFieldDefinitions($strInput,$ValueArray="",$ErrorArray="",$ForForms=true,$CSSClass="")		{
		if(empty($strInput))	{ return false; }
		
		// Include Stylesheetdefinitions
		if(empty($CSSClass))	{ $CSSClass="inputmiddle"; }
		$CSSTag = "class=\"".$CSSClass."\"";
				
		$ReturnArray=array();
		
		if($ForForms==true)	{
			// Return a complete build instruction for form fields
			$DecodeArray = explode("\r\n",$strInput);
			
			$ArrayItem = 1;
			foreach($DecodeArray as $FieldRow)	{
				$TempArray= explode(";",$FieldRow);
				$BuildInst ="";
				
				// Yes, Feld should be used, so build it
				if(isset($TempArray[1]) && $TempArray[1]==1)	{
					// Switch for different inputtypes
					$InpType=$TempArray[4];
					switch($InpType)	{
						case 2:
							// Optionbox
							// Walk through option values
							$OptionsArray=explode(",",$TempArray[7]);
							$i=1;
							foreach($OptionsArray as $Option)	{
								// Is entry selected?
								$Option = trim($Option);
								
								// Check, if Option is marked as selected
								if(strpos($Option,"*")===0)		{
									$strSelected = "checked";
									$Option = substr($Option,1);
								} else { $strSelected = ""; }
								
								// Check, if there is a selected option
								if(is_array($ValueArray) && !empty($ValueArray[$ArrayItem]))	{
									// Override master value for selected item
									$strSelected = "";
									if($i == $ValueArray[$ArrayItem])	{
										$strSelected = "checked";
									}
								}
								
								$BuildInst.="<input type=\"radio\" name=\"f_field".sprintf("%d",$TempArray[0])."\" ";
								$BuildInst.=" value=\"".$i."\" ".$strSelected.">".$Option."<br>";
								$i++;					
							}
							break;
						case 3:
							// Dropdown
							$OptionsArray=explode(",",$TempArray[7]);
							$i=1;
							$BuildInst.="<select ".$CSSTag." name=\"f_field".sprintf("%d",$TempArray[0])."\">";
							foreach($OptionsArray as $Option)	{
								// Is entry selected?
								$Option = trim($Option);
								if(strpos($Option,"*")===0)		{
									$strSelected = "selected";
									$Option = substr($Option,1);
								} else { $strSelected = false; }
								
								// Check, if there is a selected option
								if(is_array($ValueArray) && !empty($ValueArray[$ArrayItem]))	{
									// Override master value for selected item
									$strSelected = "";
									if($i == $ValueArray[$ArrayItem])	{
										$strSelected = "selected";
									}
								}
								
								$BuildInst.="<option value=\"".$i."\" ".$strSelected.">".trim($Option)."</option>";
								$i++;					
							}
							$BuildInst.="</select>";
							break;
						case 4:
							// Checkbox
							if(is_array($ValueArray) && !empty($ValueArray[$ArrayItem]))	{
								// Override master value for selected item
								if($ValueArray[$ArrayItem]=="set")	{
									$strSelected = " checked";
								} else { $strSelected = ""; }
							}
							$BuildInst.="<input type=\"checkbox\" name=\"f_field".sprintf("%d",$TempArray[0])."\"";
							$BuildInst.=" value=\"set\"".$strSelected.">".$TempArray[7];
							break;
						case 5:
							// Listbox
							$OptionsArray=explode(",",$TempArray[7]);
							$i=1;
							$BuildInst.="<select ".$CSSTag." name=\"f_field".sprintf("%d",$TempArray[0])."\" size=\"5\">";
							foreach($OptionsArray as $Option)	{
								if(strpos($Option,"*")===0)		{
									$strSelected = "selected";
									$Option = substr($Option,1);
								} else { $strSelected = false; }
								
								// Check, if there is a selected option
								if(is_array($ValueArray) && !empty($ValueArray[$ArrayItem]))	{
									// Override master value for selected item
									$strSelected = "";
									if($i == $ValueArray[$ArrayItem])	{
										$strSelected = "selected";
									}
								}
								
								$BuildInst.="<option value=\"".$i."\" ".$strSelected.">".trim($Option)."</option>";
								$i++;					
							}
							$BuildInst.="</select>";
							break;
						case 6:
							// Textarea
							if(is_array($ValueArray))	{
								// Override master value for selected item
								$strText = $ValueArray[$ArrayItem];
							} else { $strText = $TempArray[7]; }
							
							$BuildInst.="<textarea class=\"inputbig\" style=\"height:75px;\" ".
								"name=\"f_field".sprintf("%d",$TempArray[0])."\">";
							$BuildInst.=$strText."</textarea>";
							break;
						default:
							// other values build text input
							if(is_array($ValueArray))	{
								// Override master value for selected item
								$strText = $ValueArray[$ArrayItem];
							} else { $strText = $TempArray[7]; }
							
							$BuildInst.="<input type=\"text\" ".$CSSTag." name=\"f_field".sprintf("%d",$TempArray[0])."\"";
							$BuildInst.=" value=\"".$strText."\">";
							break;
					}
			
					// Encode Errorflags
					if(is_array($ErrorArray) && $ErrorArray[$ArrayItem]==false)		{
						$ImgError = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."x.gif\" valign=\"center\">";
						$BuildInst.= $ImgError;								
					}
					
					$RowEncode = array( "use"		=> $TempArray[1],
										"name"		=> $TempArray[5],
										"desc"		=> $TempArray[6],
										"control"	=> $BuildInst	);
					
					$ReturnArray[$ArrayItem]=$RowEncode;					
					
				}
				$ArrayItem++;
			}	
		}
		else
		{
			// Just return a complete array
			$DecodeArray = explode("\r\n",$strInput);
			
			foreach($DecodeArray as $FieldRow)	{
				
				$TempArray= explode(";",$FieldRow);
				$ArrayRow = array(	"findex"	=>(isset($TempArray[0])?$TempArray[0]:-1),
									"useit"		=>(isset($TempArray[1])?$TempArray[1]:0),
									"mand"		=>(isset($TempArray[2])?$TempArray[2]:0),
									"search"	=>(isset($TempArray[3])?$TempArray[3]:0),
									"name"		=>(isset($TempArray[5])?$TempArray[5]:""),
									"type"		=>(isset($TempArray[4])?$TempArray[4]:1),
									"options"	=>(isset($TempArray[7])?$TempArray[7]:""),
									"description"	=>(isset($TempArray[6])?$TempArray[6]:"") );
									
				$ReturnArray[$TempArray[0]]=$ArrayRow;
			}
		}
		
		// return the array
		return $ReturnArray;
	}
	
	
	///////////////
	// function   :		UpdateFreeFieldConfig($ConfigString="")
	//					Updates the masterconfiguration of free fields
	// 					The masterconfig is always stored with adid=0
	//
	// parameters :		$ConfigString		Encoded field configuration
	//					see	EncodeFreeFieldDefinitions for details	
	//
	// return     :		returns true or false in case of an error					
	///////////////
	
	function UpdateFreeFieldConfig($ConfigString="")		{
		
		if(empty($ConfigString))	{ return false;  }
		
		// Build SQL statement
		$sql = "UPDATE cf_adfreerows SET freecoldesc='".$ConfigString."' WHERE adid='0'";

		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;			// Database error
		}
		$result = $DB->dbupdate($sql);
								
		if($result=="0")	{
			// Try a fallback and INSERT into database
			$sql = "INSERT INTO cf_adfreerows (adid,freecoldesc) values (0,'".$ConfigString."')";
			$result = $DB->dbinsert($sql);
		} 	
		
		return $result;
	}
	
	
	///////////////
	// function   :		GetFreeFields($ArtID=-1,$ConfigOnly=false)
	//					Updates the masterconfiguration of free fields
	// 					The masterconfig is always stored with adid=0
	//
	// parameters :		$ConfigString		Encoded field configuration
	//					see	EncodeFreeFieldDefinitions for details	
	//
	// return     :		returns true or false in case of an error					
	///////////////
	
	function GetFreeFields($ArtID=-1,$ConfigOnly=false,$ReturnString=false)		{
	
		if($ArtID<0)	{ return false;  }
		
		// Build SQL statement
		if($ConfigOnly)		{
			$sql = "SELECT freecoldesc as ColumnConfig FROM cf_adfreerows WHERE adid='".$ArtID."'";
		} else {
			$sql = "SELECT * FROM cf_adfreerows WHERE adid='".$ArtID."'";	
		}	
		
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;			// Database error
		}
		$result = $DB->dbselect($sql);	
		if($result==false)		{ return false; }
		if($ReturnString==true)	{
			foreach($result as $row)	{
				return $row['ColumnConfig'];	
			}
		} else { return $result; }
	}
	
	
	///////////////
	// function   :		GetFreeFieldCont($DBArray="")
	//					Fills array with content of free fields to 
	// 					display as a string
	//
	// parameters :		$DBArray			Row of DB-Table
	//						
	//
	// return     :		returns true or false in case of an error					
	///////////////
	
	function GetFreeFieldCont($DBArray="")		{

		// Check input
		if(empty($DBArray))	{ return false;  }
	
		// Build return array
		$ReturnArray=array();
		
		$Row = 1;
		$FieldDefinitions = DecodeFreeFieldDefinitions($DBArray[0]['freecoldesc'],"","",false);
		
		if(!is_array($FieldDefinitions))	{ return false; }
		
		foreach($FieldDefinitions as $FieldRow)		{
			// Decode every single field
			if($FieldRow["useit"]==true)	{
				// We have to decode this item, its used!
				$Content ="";
							
				switch($FieldRow["type"])	{
					case 2:
						// Optionfield
						// Walk through option values
						$OptionsArray=explode(",",$FieldRow['options']);
						$i=1;
						foreach($OptionsArray as $Option)	{
							// Keep texts clean
							$Option = trim($Option);
							if(strpos($Option,"*")===0)		{
								$Option = substr($Option,1);
							}
							$field = "freecol".sprintf("%02d",$Row);
							if($i==$DBArray[0][$field])	{
								$Content = $Option;
							};
							$i++;					
						}
						break;
					case 3:
						// Dropdown
						// Walk through option values
						$OptionsArray=explode(",",$FieldRow['options']);
						$i=1;
						foreach($OptionsArray as $Option)	{
							// Keep texts clean
							$Option = trim($Option);
							if(strpos($Option,"*")===0)		{
								$Option = substr($Option,1);
							}
							$field = "freecol".sprintf("%02d",$Row);
							if($i==$DBArray[0][$field])	{
								$Content = $Option;
							};
							$i++;					
						}
						break;
					case 4:
						// controlbox
						$field = "freecol".sprintf("%02d",$Row);
						if($DBArray[0][$field]=="set")	{
							$Content = $FieldRow['name'];
							$Content.= LANG_FIELDOPTIONYES;
						} else {
							$Content = $FieldRow['name'];
							$Content.= LANG_FIELDOPTIONNO;
						}
						
						
						break;
					case 5:
						// Listbox
						// Walk through option values
						$OptionsArray=explode(",",$FieldRow['options']);
						$i=1;
						foreach($OptionsArray as $Option)	{
							// Keep texts clean
							$Option = trim($Option);
							if(strpos($Option,"*")===0)		{
								$Option = substr($Option,1);
							}
							$field = "freecol".sprintf("%02d",$Row);
							if($i==$DBArray[0][$field])	{
								$Content = $Option;
							};
							$i++;					
						}
						break;
					case 6:
						// Textarea
						$field = "freecol".sprintf("%02d",$Row);
						$Content = $DBArray[0][$field];
						break;
					default:
						// Textbox
						$field = "freecol".sprintf("%02d",$Row);
						$Content = $DBArray[0][$field];
						break;
				}
				
				// Build return array
				$ThisRow = array( 	"name"		=> (isset($FieldRow['name'])?$FieldRow['name']:""),
									"desc"		=> (isset($FieldRow['description'])?$FieldRow['description']:""),
									"content"	=> (isset($Content)?$Content:"") 
								);
								
				$ReturnArray[$Row]=$ThisRow;
			}
			$Row++;
		}
		return $ReturnArray;
	}
	
	function makePassword($Secure=false) {
        $alphaNum = array(
                '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b',
                'c', 'd', 'e', 'f', 'g', 'h', 'k', 'm', 'n',
                'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
                'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'K', 'L',
                'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
                'Y', 'Z'
        );
        srand ((double) microtime() * 1000000);
        
        // this sets the limit on how long the password is
        $pwLength = "8"; 
        $newPass = "";
        for($i = 1; $i <=$pwLength; $i++) {
                $newPass .= $alphaNum[(rand(0,52))];
        }
        return ($Secure==true) ? md5($newPass) : $newPass;
	}
	
	
	///////////////
	// function   :		SendLoginData($EmailIn="")
	//					Sends username and new password
	//
	// parameters :		$EmailIn			EmailAdress
	//						
	//
	// return     :		returns true or false in case of an error					
	///////////////
	
	function SendLoginData($EmailIn="",$strLanguage="")			{
		
		if(empty($strLanguage))	{ 
			$strLanguage = GetConfig('DEFMAILLANG'); 
		}

		if(empty($EmailIn))		{ return ERR_LOGIN_PARAMETER; }

		// Build SQL
		$sql= "SELECT cf_users.* ".
			"FROM cf_users WHERE useremail='".$EmailIn."' ".
			"LIMIT 1";
				
		// Open database
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			return ERR_COMMON;				// Database error
		}
		
		$data = $DB->dbselect($sql);
		if(!is_array($data) || sizeof($data)==0)	{
			return ERR_USER_NOT_FOUND;
		}
				
		// Check, if alter pass was set 
		if(!empty($data[0]['useralterpass']) && !is_null($data[0]['userpasswordset']))	{
			
			$dtAlterPassSet = MysqlToTime($data[0]['userpasswordset']);
			$dtMinPasswordAge = mktime() - 3600;		// Sub 1 hour

			if($dtAlterPassSet < $dtMinPasswordAge)	{		
				return ERR_ALTERPASSWORD_TOO_YOUNG;		
			}
		}

		// Build a new password and write it to database
		$NewPassword  = makePassword(false);
		
		// Set new password in database
		$sql = "UPDATE cf_users SET useralterpass='".md5($NewPassword)."', ".
			"userpasswordset=now() ".
			"WHERE userid=".$data[0]['userid'];
		
		$AffRows = $DB->dbupdate($sql);
		if($AffRows<=0)		{ 
			return ERR_SETTING_PASSWORD;	
		}
		
		// Send email
		require_once("inc/postoffice.class.php");
		
		$oPO = new PostOfficeLostPassword($data[0]['userid']);
		$oPO->SetPassword($NewPassword);
		$bSuccess = $oPO->Send();

		return ($bSuccess?SUCCESS:ERR_SEND_MAIL);
	}
	
	
	///////////////
	// function   :		SendAdCheckRequest($ArtID=-1,$InfoOnly=false,$strLanguage="")
	//					Send a request to the Administrator to check a new ad
	//					and activate it
	//
	// parameters :		$ArtID			Article identification
	//					$bInfoOnly		Should it be only a information for the Admin
	//									(Ad is showed directly after submit, no request to release)
	//						
	//
	// return     :		returns true or false in case of an error					
	///////////////
	
	function SendAdCheckRequest($iAdId=-1,$bInfoOnly=FALSE,$strLanguage="")			{
		
		// Check parameters
		if((integer)$iAdId<=0)	{
			return FALSE;
		}
		
		if(empty($strLanguage))	{
			$strLanguage = GetConfig("DEFMAILLANG");
		}
	
		// Open database and read ad data
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{
			return FALSE;
		}

		
		// Build security codes and insert into database
		$strReleaseLink = "";
		
		if(!$bInfoOnly)		{
			
			$strCode = md5("NeW@AdSuBmITeD**aT:".microtime());
			$sql = "INSERT INTO cf_secsub (scsadid,scspassword) VALUES (".$iAdId.",'".
				$strCode."')";			
			$iInsertId = $DB->dbinsert($sql);
			
			if($iInsertId<=0)	{
				return FALSE;
			}
			
			$strReleaseLink = "<a href=\"http://".GetConfig('PD_WEBURL')."/".GetConfig('PD_SCRIPTPATH').
				"releasesubmit.php?adid=".$iAdId."&seccode=".$strCode."\">".LANG_RELEASE_ACTIVATE_LINK."</a>";
		} else {
			
			$strReleaseLink = "<i>".LANG_RELEASE_NO_ACTIVATION."</i>";
		}
		
		/*
			Get postoffice and send mail
		*/	
		$oPO = new PostOfficeAdInfo($iAdId);
		$oPO->SetReleaseLink($strReleaseLink);
		$bSuccess = $oPO->Send();

		return $bSuccess;
	}
	
	
	
	function SetUserReleaseCode($iUserId=-1)		{

		if($iUserId<=0)		{
			return FALSE;
		}
		
		// Build release code and URLs
		$strReleaseCode = md5("nEW@USERInSErted**aT:".microtime());
				
		// Insert release code
		$DB = new SQLDatabase();
		if(!$DB->dbconnect())	{ return FALSE; }
				
		$sql = "UPDATE cf_users SET ".
			"userreleased=0, ".
			"userreleasecode='".$strReleaseCode."' ".
			"WHERE userid=".$iUserId;
		$iAffRows = $DB->dbupdate($sql);
		if($iAffRows<=0)	{ 
			return FALSE;
		} 
	
		return TRUE;
	}
	
	
	function ReleaseUser($iUserId=-1,$strCode="")		{

		if($iUserId<=0)		{
			return -1;
		}
		
		// Get user data
		$UserData = GetUserDetails($iUserId);
		if(!is_array($UserData))	{
			return ERR_RELEASE_UNKNOWN_USER;
		} 
		
		// Check code
		if($UserData['userreleased']==1)	{
			return ERR_RELEASE_ALREADY_RELEASED;
		}
		
		if($UserData['userreleasecode']	== $strCode)	{

			// Update user account
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{
				return FALSE;
			}			
					
			$sql = "UPDATE cf_users SET ".
				"userreleased=1, ".
				"userreleasecode='' ".
				"WHERE userid=".$iUserId;
			$iAffRows = $DB->dbupdate($sql);
			return ($iAffRows>0?SUCCESS:ERR_COMMON);		
		} else {
			return ERR_RELEASE_CODE_WRONG;
		}
	}
	
	
	///////////////
	// function   :		ReleaseAd($ArtID=-1,$SecCode="")
	//					Activates a newly submitted ad
	//
	// parameters :		$ArtID			Article identification
	//					$SecCode		Security code
	//
	// return     :		returns true or an error value 					
	///////////////
	
	function ReleaseAd($ArtID=-1,$SecCode="",$AdminMode=false)		{
		if($ArtID<=0)	{ return 0; }
		
		// Build SQL
		$sql= "SELECT scspassword as password FROM cf_secsub WHERE scsadid='".$ArtID."' LIMIT 1";
		
		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return -1;				// Database error
		}
		
		if($AdminMode!=true)	{
			$data = $DB->dbselect($sql);	
			if($data==false)	{
				return -2;				// Not found
			}
		}
				
		if($AdminMode || $SecCode == $data[0]['password'])	{
			// Everything okay
			$sql = "UPDATE cf_ads SET adchecked=1 WHERE adid='".$ArtID."'";
			$DB->dbupdate($sql);
			$sql = "DELETE FROM cf_secsub WHERE scsadid='".$ArtID."'";
			$DB->dbdelete($sql);
			return true;
		} else {
			// Return wrong identification error	
			return -3;
		}
	}

	
		
	// Convert to double value		
	function toDouble($mixInput, $iDec = 2)	{
		$dRet = 0.00;
		if(is_string($mixInput))	{
			// Convert , to . decimal point
			$mixInput = str_replace(",",".",$mixInput);
		}	
		$dRet = (double)$mixInput;
		$dRet = sprintf("%.".$iDec."f",$dRet);
		return $dRet;
	}
		
	// Convert to integer	
	function toInt($mixInput)		{
		return (integer)$mixInput;
	}
	
	// Convert input data to safe strings
	// - remove javascript (XSS)
	// - remove HTML-tags
	// - remove SQL injections
	function toSafeString($strInput,$bForSQL=TRUE)	{
		$strRet = "";
		
		// Handle null values
		if(is_null($strInput))	{ return NULL; }
		
		// Convert to string
		$strInput = (string)$strInput;

		// Delete whitespaces (trailing and leading)
   		$strInput = trim($strInput);

		// Remove javascript crap			
		$strRet = preg_replace("/(\<script)(.*?)(script>)/si", "", $strInput);

		// Keep HTML-comment intact
		$strRet = str_replace("<!--", "&lt;!--", $strRet);
		$strRet = preg_replace("/(\<)(.*?)(--\>)/mi", "".nl2br("\\2")."", $strRet);
					
		// Strip tags
		// as long as we find tags replace them
		while($strRet != strip_tags($strRet)) {
      		$strRet = strip_tags($strRet);
   		}
   		       		
		// SQL injection
		if($bForSQL)	{
			// New way to escape strings - only for PHP 5 with mysqli-extension
			//$strRet = mysql_real_escape_string($strRet);
			$strRet = addslashes($strRet);
		}			
		return ($strRet);	
	}
	
	function CropProtocol($strInput)	{
		return preg_replace("/(.*?)\/\//i", "", $strInput);	
	}
	
	function ReplaceDoubleSlash($strInput)	{
		return preg_replace("/(\/\/)/i", "/", $strInput);	
	}
	
	
	function AddSlash($strInput)	{
		if(substr($strInput,strlen($strInput)-1,1)!="/")	{
			$strInput.= "/";
		}
		return $strInput;
	}
	
	function CheckEmail($strEmail)	{
		return (eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$strEmail));
	}
	
}
?>