<?php

	/**
	 *	GUI elements
	 * 	
	 * 	Create content of selectable GUI-elements	  
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */


	function GetDurationForDropDown($strSelected="30DAYS", $bUnlimited=FALSE)		{
		
		$arrDurations = array(	"7DAYS"		=> "7 ".LANG_DURATIONDAYS,
								"14DAYS"	=> "14 ".LANG_DURATIONDAYS,
								"30DAYS"	=> "30 ".LANG_DURATIONDAYS,
								"60DAYS"	=> "60 ".LANG_DURATIONDAYS,
								"180DAYS"	=> "180 ".LANG_DURATIONDAYS,
								"360DAYS"	=> "360 ".LANG_DURATIONDAYS		);
								
		$strOptions = "";
		
		foreach($arrDurations as $key=>$value)	{
			$strOptions.= "<option value=\"".$key."\"".
				(strtoupper($strSelected)==strtoupper($key)?" selected":"").">".
				$value."</option>";
		}

		if($bUnlimited)	{
			$strOptions.= "<option value=\"UNLIMITED\"".
				(strtoupper($strSelected)=="UNLIMITED"?" selected":"").">".
				LANG_DURATIONUNLIMITED.
				"</option>";
		}
		
		return $strOptions;
	}
	
	
	function GetSortOrderForDropDown($iSelected = AD_ORDER_INDATE)	{
		
		$arrSortOrders = array(		AD_ORDER_TITLE			=> LANG_SORTORDERTITLE, 
									AD_ORDER_TITLE_DESC		=> LANG_SORTORDERTITLEDESC,
									AD_ORDER_INDATE			=> LANG_SORTORDERINDATE,
									AD_ORDER_INDATE_DESC	=> LANG_SORTORDERINDATEDESC,
									AD_ORDER_VIEWS			=> LANG_SORTORDERVIEWS,
									AD_ORDER_VIEWS_DESC		=> LANG_SORTORDERVIEWSDESC,
									AD_ORDER_PICTURES		=> LANG_SORTORDERPICTURES,
									AD_ORDER_PICTURES_DESC	=> LANG_SORTORDERPICTURESDESC	);
		
		$strOptions = "";
		foreach($arrSortOrders as $key=>$value)	{				
			$strOptions.= "<option value=\"".$key."\"".
				($key==$iSelected?" selected":"").">".
				$value."</option>";
		}
		return $strOptions;
	}
	
		
	function GetTimeSpanForDropDown($iSelected = TIMESPAN_UNLIMITED)	{
		
		$arrTimeSpans = array(		TIMESPAN_UNLIMITED	=> LANG_DURATIONUNLIMITED,
									TIMESPAN_1DAY		=> "1 ".LANG_DURATIONDAY,
									TIMESPAN_3DAYS		=> "3 ".LANG_DURATIONDAYS,
									TIMESPAN_1WEEK		=> "1 ".LANG_DURATIONWEEK,
									TIMESPAN_2WEEKS		=> "2 ".LANG_DURATIONWEEKS,
									TIMESPAN_1MONTH		=> "4 ".LANG_DURATIONWEEKS);
	
		$strOptions = "";
		foreach($arrTimeSpans as $key=>$value)	{				
			$strOptions.= "<option value=\"".$key."\"".
				($key==$iSelected?" selected":"").">".
				$value."</option>";
		}
		return $strOptions;									
	}
	
	
	function GetFilesFromDirectory($strDirectory="",$strFileSelected="",$bDummy = TRUE)	{
		$strOptions = "";

		if(empty($strDirectory) || !is_dir($strDirectory))	{
			return "<option value=\"\">Directory not found</option>";	
		}

		if($bDummy)	{
			$strOptions .= "<option value=\"\">----</option>";
		}
		
		
		$hDir  = opendir($strDirectory);
		while (false !== ($filename = readdir($hDir))) {
		   $arrFiles[] = $filename;
		}
		
		foreach($arrFiles as $filename)	{
			if(!in_array($filename,array(".","..")))	{
				$strOptions .= "<option value=\"".$filename."\"".
					($strFileSelected==$filename?" selected":"").">".
					$filename."</option>";
			}						
		}	
		return $strOptions;		
	}

	
	function GetPictureEditList($oPicList)	{

		$strPictureList = "<table width=\"100%\" cellspacing=\"0\">".
			"<tr>".
			"<th width=\"25%\">Bild</th>".
			"<th width=\"60%\">Titel</th>".
			"<th width=\"15%\">Mark</th>".
			"<tr>";
		
		$arrPics = $oPicList->GetPicArray();
		if(is_array($arrPics) && sizeof($arrPics)>0)	{
			
			$i=0;
			foreach($arrPics as $key=>$oPic)		{
				
				/* @var $oPic Picture */
				$strPictureList.= "<tr class=\"".($i%2==0?"nonhighlighted":"highlighted")."\">".
					"<td class=\"previewimage\" >".
						"<img src=\"".GetConfig('PD_USERGRAPHICS')."tn_".$oPic->strLink."\">".
					"</td>".
					"<td class=\"formcellcontent\">".(empty($oPic->strTitle)?"<i>".LANG_PICTURE_NO_DESCRIPTION."</i>":$oPic->strTitle)."</td>".
					"<td class=\"formcellcontent\" valign=\"center\"><input type=\"checkbox\" name=\"f_dellist[]\" value=\"".$oPic->iId."\"</td>".
					"</tr>";
					
					$i++;
			}
			
			// Add summary row
			$strPictureList.= "<tr>".
				"<td colspan=\"3\" class=\"summaryrow\" style=\"text-align:right;\">".
					"<input type=\"submit\" name=\"f_delete\" value=\"Markierte Bilder lschen!\" ".
					"class=\"button\" style=\"width:150px;\">".
				"</td>".
				"</tr>";
			
		} else {
			$strPictureList.= "<tr><td colspan=\"3\" align=\"center\">".
				LANG_NOPICAVAILABLE.
				"</td>".
				"</tr>";
		}
		$strPictureList.= "</table>";		
		
		return $strPictureList;		
		
	}
	
	
?>