<?php

	/**
	 * Parse mail text and replace variables
	 * 
	 * 
	 * @todo 	combine regular and mail template engine
	 * @todo 	Extend class to use recursive parsing
	 * 
	 */
	class MailTemplate	{
		
		// 
		// Properties
		//
		var $strTemplate="";
		var $strContent = "";
		var $arrTemplateVars = array();

		
		function MailTemplate()	{

		}
			
		/**
		 * Set a new substitution
		 *
		 * @param Name of parameter
		 * @param Value of parameter
		 */
		function Set($strName,$strValue)	{		
			if(!empty($strName))	{
				$this->arrTemplateVars[strtoupper($strName)] = $strValue;
			}
			return TRUE;
		}
		
		function GetVar($strName)	{
			if(empty($strName))	{ return ""; }
			if(!array_key_exists(strtoupper($strName),$this->arrTemplateVars))	{
				return "[Variable '".$strName."' not defined]";
			} else {
				return (string)$this->arrTemplateVars[strtoupper($strName)];
			}
		}
		
		/**
		 * Set a group of substitutions
		 *
		 * @param Name of parameter
		 * @param Value of parameter as array
		 */
		function SetGroup($arrElements)	{
			if(!is_array($arrElements))	{
				return FALSE;
			}
			
			foreach($arrElements as $key=>$value)	{
				$this->arrTemplateVars[strtoupper($key)] = $value;
			}
			return TRUE;
		}
		

		function SetTemplate($strTemplate="")	{
			if(!$this->CheckTemplate($strTemplate))	{
				return FALSE;
			}
			$this->strTemplate = $strTemplate;
			return TRUE;
		}
			
				
		/**
		 * Get content of parsed template
		 *
		 * @access public
		 */
		function ParseContent()	{

			// Read file
			if(!$this->ReadFile())	{
				return FALSE;	
			}
			
			// Late parse - only if the content is needed
			$this->Parse();
				
			// Return the content
			return TRUE;
		}
			
		
		function GetContent()	{
			return $this->strContent;
		}
		
		
		/**
		 * Parse template content
		 *
		 * @access protected
		 * @return boolean
		 */
		function Parse()		{
			
			// Parse iif-structure
			$strPattern = "/\{iif (.*?)\}(.*?)\{else\}(.*?)\{\/iif(.*?)\}/ise";
			$this->strContent = preg_replace($strPattern, "\$this->EvalIif('\\1','\\2','\\3')",$this->strContent);
			
			// Parse if-structure
			$strPattern = "/\{if (.*?)\}(.*?)\{\/if(.*?)\}/ise";
			$this->strContent = preg_replace($strPattern, "\$this->EvalIf('\\1','\\2')",$this->strContent);
				
			// Replace all defined variables
			$strPattern = "/\{([a-zA-Z0-9_.]+)\}/ie";
			$this->strContent = preg_replace($strPattern,"\$this->GetVar('\\1')",$this->strContent);

			return TRUE;			
		}
		
		
		function ReadFile()	{
			$strBuffer = "";
			
			$hFile = @fopen($this->strTemplate,"r");
			if($hFile)	{
				while($buffer=@fgets($hFile,4096))	{
					$strBuffer .= $buffer;	
				}
				fclose($hFile); 
			} else {
				return FALSE;
			}
			$this->strContent = $strBuffer;
			return TRUE;
		}
		
			
		function CheckTemplate($strTemplate="")	{
			if(!empty($strTemplate) && is_file($strTemplate) && is_readable($strTemplate))	{
				return TRUE;
			} else {
				return FALSE;
			}
		}
		
		
		//
		// Methods used to replace parsed values
		//
		function EvalIif($strVarName, $strAlt1, $strAlt2)		{
			return($this->GetVar($strVarName)==TRUE?$strAlt1:$strAlt2);
		}
		
		function EvalIf($strVarName, $strMessage)		{
			return($this->GetVar($strVarName)==TRUE?$strMessage:"");
		}
	}
	
	
	/*
		static functions
	*/
	function SetUserInfoToTemplate(&$oTemplate,$arrUserData)	{
		
		$arrSubst = array(	"UserRealname" 	=> $arrUserData['userrealname'],
							"UserId"		=> $arrUserData['userid'],
							"UserName"		=> $arrUserData['username'],
							"UserAddress1"	=> $arrUserData['useradress1'],
							"UserAddress2"	=> $arrUserData['useradress2'],
							"UserCountry"	=> $arrUserData['usercountry'],
							"UserCountryLong"	=> (array_key_exists($arrUserData['usercountry'],$GLOBALS['COUNTRIES'])?
								$GLOBALS['COUNTRIES'][$arrUserData['usercountry']]:"???"),
							"UserTitle"		=> $arrUserData['usertitle'],
							"UserZip"		=> $arrUserData['userzip'],
							"UserCity"		=> $arrUserData['usercity'],
							"UserTel"		=> $arrUserData['usertel'],
							"UserFax"		=> $arrUserData['userfax'],
							"UserEmail"		=> $arrUserData['useremail'],
							"UserYahoo"		=> $arrUserData['useryahoo'],
							"UserMsn"		=> $arrUserData['usermsn'],
							"UserSkype"		=> $arrUserData['userskype'],
							"UserYahoo"		=> $arrUserData['useryahoo'],
							"UserHomepage"	=> $arrUserData['userhomepage'],
							"UserMobile"	=> $arrUserData['usermobile'],
							"UserAgeChecked"	=> $arrUserData['username'],
							"UserRights"		=> $arrUserData['username'] 
		);
		
		$oTemplate->SetGroup($arrSubst);
	
		return TRUE;
	}
	
	
	function SetAdInfoTemplate(&$oTemplate,$arrAdData)	{
		
		$arrSubst = array(	"AdTitle" 		=> $arrAdData['adtitle'],
							"AdCategory"	=> $arrAdData['catname'],
							"AdText"		=> $arrAdData['adtext'],
							"AdLink"		=> "http://".GetConfig('PD_WEBURL')."/".GetConfig('PD_SCRIPTPATH').
								"showad.php?adid=".$arrAdData['adid'],	
							"AdId"			=> $arrAdData['adid'],
							"AdInDate"		=> FormatDateDt($arrAdData['adindate']),
							"AdOutDate"		=> FormatDateDt($arrAdData['adoutdate']),
							"AdName"		=> $arrAdData['adname'],
							"AdZip"			=> $arrAdData['adzip'],
							"AdCity"		=> $arrAdData['adcity'],
							"AdCountry"		=> $arrAdData['adcountry'],
							"AdCountryLong"	=> (array_key_exists($arrAdData['adcountry'],$GLOBALS['COUNTRIES'])?
								$GLOBALS['COUNTRIES'][$arrAdData['adcountry']]:"???"),
							"AdIpAddress"	=> $arrAdData['adipadress'],
							"AdViews"		=> $arrAdData['adviewed'],
							"AdContacts"	=> $arrAdData['adcontcounter'],
							"AdTells"		=> $arrAdData['adtellcounter'],
							"AdEmail"		=> $arrAdData['ademail'],
							"AdFax"			=> $arrAdData['adfax'],
							"AdPhone"		=> $arrAdData['adtel'],
							"AdMobile"		=> $arrAdData['admobile'],
							"AdHomepage"	=> $arrAdData['adhomepage'],
							"AdFeatured"	=> ($arrAdData['adfeatured']==1?TRUE:FALSE),
							"AdIcq"			=> $arrAdData['adicq'],
							"AdAim"			=> $arrAdData['adaim'],
							"AdSkype"		=> $arrAdData['adskype'],
							"AdMsn"			=> $arrAdData['admsn'],
							"AdYahoo"		=> $arrAdData['adyahoo'],
							"AdAgeRestricted"	=> ($arrAdData['adagerestricted']==1?TRUE:FALSE),
							"AdType"		=> $arrAdData['adtype'],
							"AdTypeLong"	=> DecodeAdType($arrAdData['adtype'])
		);
		
		// Add picture/thumbnail link
		$strPicFullsize = "http://".GetConfig("PD_WEBURL")."/".GetConfig("PD_SCRIPTPATH").
			(empty($arrAdData['adpiclink'])?GetConfig("PD_SCRIPTGRAPHICS")."no_image.jpg":
			GetConfig("PD_USERGRAPHICS").$arrAdData['adpiclink']);

		$strPicThumbnail = "http://".GetConfig("PD_WEBURL")."/".GetConfig("PD_SCRIPTPATH").
			(empty($arrAdData['adpiclink'])?GetConfig("PD_SCRIPTGRAPHICS")."no_image.jpg":
			GetConfig("PD_USERGRAPHICS")."tn_".$arrAdData['adpiclink']);

		$arrSubst['AdPicLinkFullsize'] = $strPicFullsize;
		$arrSubst['AdPicLinkThumbnail'] = $strPicThumbnail;
		
		$oTemplate->SetGroup($arrSubst);
		
		return TRUE;
	}
	
	
	function SetPicListInfoTemplate(&$oTemplate,$oPicList,$bHideUnreleased=FALSE)		{
		
		/* 	@var $oPicList PictureList */
		/*	@var $oPic Picture	*/		
		if(is_null($oTemplate) || is_null($oPicList))	{
			return FALSE;
		}
		
		$strFullDisplay = "";
		$strPlainDisplay = "";
		
		$arrPictures = $oPicList->GetPicArray();
		
		if(is_array($arrPictures) && sizeof($arrPictures))	{
			foreach($arrPictures as $oPic)	{

				$strFullDisplay.= "<div>".
					"<img src=\"http://".GetConfig("PD_WEBURL")."/".GetConfig("PD_SCRIPTPATH").
						GetConfig("PD_USERGRAPHICS")."tn_".$oPic->strLink."\" alt=\"".$oPic->strTitle."\" \>".
					"</div>";
				
				$strPlainDisplay.= "<a href=\"http://".GetConfig("PD_WEBURL")."/".GetConfig("PD_SCRIPTPATH").
						GetConfig("PD_USERGRAPHICS").$oPic->strLink."\">".$oPic->strTitle."</a>";
			}
		}

		// Set into template		
		$oTemplate->SetGroup( array(	"PicturesAttached"	=> sizeof($arrPictures),
										"PicInfoFull"	=> $strFullDisplay,
										"PicInfoPlain"	=> $strPlainDisplay ));

		return TRUE;								
	}
	
	
?>