<?php


	class Statistics	{

		var $iAdsTotal = 0;
		var $dAdsPerDayTotal = 0;
		var $iFirstAdIn = 0;
		var $iMarketRunningTime = 0;
		var $iUserCount = 0;
		
		var $iCategoryCount = 0;
		var $iCategoryMaxLevel = 0;
		var $arrTopCategories = array();
		
		var $arrNewAds = array();
		
		var $arrTopUsers = array();
		var $arrTopViewedRelative = array();
		var $arrTopViewedAbsolute = array();
		
		var $iMaxLimit = 30;

		
		
		function GetStatistics()	{
			
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{
				return FALSE;
			}
				
			// Execute queries
			$this->GetMarketKeyFigures($DB);
			$this->GetCategoryCount($DB);
			$this->GetUserTopList($DB);
			$this->GetTopViewed($DB);
			$this->GetNewAdStatistics($DB);
			$this->GetTopCategories($DB);
			$this->GetUserCount($DB);
			
			return TRUE;
		}
		
		
		function GetUserCount(&$DB)	{
			
			$this->iUserCount = 0;
			
			$sql = "SELECT COUNT(*) as UserCount ".
				"FROM cf_users ";
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)	{
				$this->iUserCount = (integer)$data[0]['UserCount'];
			}
			return TRUE;
		}
		
		
		function GetMarketKeyFigures(&$DB)	{
			
			$this->iAdsTotal = 0;
			$this->dAdsPerDayTotal = 0;
			$this->iFirstAdIn = 0;
			$this->iMarketRunningTime = 0;
						
			$sql = "SELECT COUNT(*) as AdCounter,MIN(adindate) as FirstIn, ".
				"DATEDIFF(curdate(),MIN(adindate))+1 as MarketRunningTime, ".
				"COUNT(*) / (DATEDIFF(curdate(),MIN(adindate))+1) as AdsPerDay ".
				"FROM cf_ads";
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)	{
				$this->iAdsTotal = $data[0]['AdCounter'];
				$this->dAdsPerDayTotal = $data[0]['AdsPerDay'];
				$this->iFirstAdIn = $data[0]['FirstIn'];
				$this->iMarketRunningTime = $data[0]['MarketRunningTime'];
			}
			return TRUE;
		}
		
		
		function GetCategoryCount(&$DB)		{
			
			$this->iCategoryCount = 0;
			$this->iCategoryMaxLevel = 0;
			
			$data = $DB->dbselect("SELECT COUNT(*) as Counter, MAX(statlevel) as MaxLevel FROM cf_catstats");
			
			if(is_array($data) && sizeof($data)>0)		{
				$this->iCategoryCount = $data[0]['Counter'];
				$this->iCategoryMaxLevel = $data[0]['MaxLevel'];
			}
			return TRUE;
		}
		
		
		function GetUserTopList(&$DB)	{
			
			$this->arrTopUsers = array();
			
			$sql = "SELECT aduserid, COUNT(*) as AdCount, MAX(adindate) as LastIn,".
				"cf_users.username, cf_users.userrealname, cf_users.usercountry, cf_users.userzip, ".
				"cf_users.usercity, cf_users.usercreatedate ".
				"FROM cf_ads ".
				"LEFT OUTER JOIN cf_users on cf_users.userid=cf_ads.aduserid ".
				"GROUP BY aduserid ".
				"ORDER BY AdCount DESC ".
				"LIMIT ".$this->iMaxLimit;
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)		{
				
				foreach($data as $element)	{
					$arrEntry = array(	"USERID"	=>	$element['aduserid'],
										"ADCOUNT"	=>	$element['AdCount'],
										"LASTIN"	=>	MysqlToTime($element['LastIn']),
										"CREATED"	=>	MysqlToTime($element['usercreatedate']),
										"USERNAME"	=>	$element['username'],
										"USERINFO"	=>	$element['userrealname']." (".
														$element['usercountry']."-".$element['userzip']." ".
														$element['usercity'].")"
					);
					$this->arrTopUsers[] = $arrEntry;
				}
			}
			return TRUE;
		}
		
		
		function GetTopViewed(&$DB)	{
			
			$this->arrTopViewedRelative = array();
			$this->arrTopViewedAbsolute = array();
			
			// Relative
			$sql = "SELECT adid, adtitle, adindate, adviewed, DATEDIFF(curdate(), adindate)+1 as RunningTime, ".
				"(adviewed / (DATEDIFF(curdate(), adindate)+1)) as ViewsPerDay ".
				"FROM cf_ads ".
				"WHERE (DATEDIFF(curdate(), adindate)+1) > 3 ".
				"ORDER BY ViewsPerDay DESC ".
				"LIMIT ".$this->iMaxLimit;
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)	{
				foreach ($data as $element)		{	
					$arrEntry = array(	"ADID"		=> $element['adid'],
										"ADTITLE"	=> $element['adtitle'],
										"ADINDATE"	=> MysqlToTime($element['adindate']),
										"ADVIEWED"	=> $element['adviewed'],
										"ADRUNNING"	=> $element['RunningTime'],
										"ADVIEWSPERDAY"	=> $element['ViewsPerDay']	
					);
					$this->arrTopViewedRelative[] = $arrEntry;		
				}
			}
			
			// Absolute
			$sql = "SELECT adid, adtitle, adindate, adviewed, DATEDIFF(curdate(), adindate)+1 as RunningTime, ".
				"(adviewed / (DATEDIFF(curdate(), adindate)+1)) as ViewsPerDay ".
				"FROM cf_ads ".
				"ORDER BY adviewed DESC ".
				"LIMIT ".$this->iMaxLimit;
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)	{
				foreach ($data as $element)		{	
					$arrEntry = array(	"ADID"		=> $element['adid'],
										"ADTITLE"	=> $element['adtitle'],
										"ADINDATE"	=> MysqlToTime($element['adindate']),
										"ADVIEWED"	=> $element['adviewed'],
										"ADRUNNING"	=> $element['RunningTime'],
										"ADVIEWSPERDAY"	=> $element['ViewsPerDay']	
					);
					$this->arrTopViewedAbsolute[] = $arrEntry;		
				}
			}	
			return TRUE;
		}
		
		
		function GetNewAdStatistics(&$DB)	{
			
			$this->arrNewAds = array();
			
			$arrTimeSpans = array(3,7,10,14,30,60);
			foreach($arrTimeSpans as $iTimeSpan)	{
				
				$sql = "SELECT COUNT(*) as AdCount, (COUNT(*) / ".$iTimeSpan.") as AdsPerDay ".
					"FROM cf_ads ".
					"WHERE adindate > DATE_SUB(curdate(), INTERVAL ".$iTimeSpan." DAY)";
				$data = $DB->dbselect($sql);
				
				if(is_array($data) && sizeof($data)>0)	{
					$arrEntry = array(	"TIMESPAN"	=> $iTimeSpan, 
										"ADCOUNT"	=> $data[0]['AdCount'],
										"ADSPERDAY"	=> $data[0]['AdsPerDay']	);
					$this->arrNewAds[] = $arrEntry;	
				}
			}
			return TRUE;
		}
		
		
		function GetTopCategories(&$DB)	{
			
			$this->arrTopCategories = array();
			
			$sql = "SELECT cf_catstats.statcatid, cf_catstats.statadcount, cf_catstats.statlastin, ".
				"cf_categories.catname ".
				"FROM cf_catstats ".
				"LEFT OUTER JOIN cf_categories ON cf_categories.catid = cf_catstats.statcatid ".
				"ORDER BY statadcount DESC ".
				"LIMIT ".$this->iMaxLimit;
			$data = $DB->dbselect($sql);
			
			if(is_array($data) && sizeof($data)>0)	{
				foreach($data as $element)	{		
					$arrEntry = array(	"CATID"		=> $element['statcatid'],
										"CATADCOUNT"=> $element['statadcount'],
										"CATLASTIN"	=> MysqlToTime($element['statlastin']),
										"CATNAME"	=> $element['catname']
					);
					$this->arrTopCategories[] = $arrEntry;		
				}
			}
			return TRUE;
		}
		
	}


?>