<?php

	define("UPLOAD_SUCCESS",1);
	define("ERR_UPLOAD_SIZE_TOO_BIG",-10000);
	define("ERR_UPLOAD_NOT_FINISHED",-10001);
	define("ERR_UPLOAD_NO_FILE",-10002);

	define("FILE_CAT_UNKNOWN",0);
	define("FILE_CAT_PICTURE",1);
	define("FILE_CAT_DOCUMENT",2);
	define("FILE_CAT_VIDEO",3);
	define("FILE_CAT_HTML",4);
	
	define("FILE_TYPE_UNKNOWN",0);
	define("FILE_TYPE_JPG",1);
	define("FILE_TYPE_PNG",2);
	define("FILE_TYPE_GIF",3);
	

	class Upload	{
		
		var $arrFiles = array();
		
		var $bUploaded = FALSE;
		var $iFileSize = 0;
		var $iUploadError = 0;
		var $strFileName = "";
		var $strMimeType = "";
		var $strFileTemp = "";
		var $iFileType = FILE_TYPE_UNKNOWN;
		var $iFileCategory = FILE_CAT_UNKNOWN;
		var $strFileExtension = "unknown";
		
		/*
			Constructor
			accepts FILES-Array as supported by PHP
		*/
		function Upload($arrFiles)	{
			if(!is_array($arrFiles))	{
				return NULL;
			} 
			$this->arrFiles = $arrFiles;
			$this->Init();
		}

		/*
			Check uploaded file
		*/
		function IsFileUploaded()	{
			return ($this->iUploadError==UPLOAD_ERR_NO_FILE?FALSE:TRUE);
		}
		
		function IsSizeCorrect()	{
			return (in_array($this->iUploadError,array(UPLOAD_ERR_INI_SIZE,UPLOAD_ERR_FORM_SIZE))?FALSE:TRUE);
		}
		
		function IsFileComplete()	{
			return ($this->iUploadError==UPLOAD_ERR_PARTIAL?FALSE:TRUE);
		}
		
		function IsPicture()	{
			return ($this->iFileCategory==FILE_CAT_PICTURE?TRUE:FALSE);
		}
		
		function IsVideo()		{
			return ($this->iFileCategory==FILE_CAT_VIDEO?TRUE:FALSE);	
		}
		
		function IsDocument()	{
			return ($this->iFileCategory==FILE_CAT_DOCUMENT?TRUE:FALSE);	
		}
		
		function GetFileExtension()		{
			return $this->strFileExtension;
		}
		
		function GetFileType()	{
			return ($this->iFileType);			
		}
		
		
		/*
			File information
		*/
		function GetFileName()	{
			return $this->strFileName;
		}
		

		function GetSize()	{
			return (integer)$this->iFileSize;	
		}
		
		
		function MoveUpload($strDestination)	{
			if(!move_uploaded_file($this->strFileTemp,$strDestination))	{
				return FALSE;
			}
			return TRUE;			
		}
		
				
		/*
			Protected
		*/		
		function Init()		{
			
			// Get PHP information about upload
			$this->strFileTemp = $this->arrFiles['tmp_name'];
			$this->strFileName = $this->arrFiles['name'];
			$this->strMimeType = $this->arrFiles['type'];
			$this->iFileSize = $this->arrFiles['size'];
			$this->iUploadError = $this->arrFiles['error'];

			// Decode mime type
			$this->DecodeMimeType();

			return TRUE;		
		}
		
		
		function DecodeMimeType()	{
			
			// Determine which Filetype we got
	   		switch (strtoupper($this->strMimeType)) {
				
	   			case "IMAGE/JPG": case "IMAGE/JPEG": case "IMAGE/PJPEG":
	   				$this->iFileType = FILE_TYPE_JPG;
					$this->iFileCategory = FILE_CAT_PICTURE;
					$this->strFileExtension = "jpg";
	   				break;
	   				
				case "IMAGE/PNG": case "IMAGE/X-PNG":
					$this->iFileType = FILE_TYPE_PNG;
					$this->iFileCategory = FILE_CAT_PICTURE;
					$this->strFileExtension = "png";	
					break;

				case "IMAGE/GIF":
					$this->iFileType = FILE_TYPE_GIF;
					$this->iFileCategory = FILE_CAT_PICTURE;
					$this->strFileExtension = "gif";
					break;	
					
				default:
					$this->iFileType = FILE_TYPE_UNKNOWN;
					$this->iFileCategory = FILE_CAT_UNKNOWN;
					$this->strFileExtension = "unknown";	
					break;
	   		}
			return TRUE;
		}
	}

	
?>