<?php		

	/**
	 *	Main / frontpage script
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	
	
	// Include everything classAd needs
	require "inc/includer.inc.php";

	
	//
	// Init variables
	//
	$WelcomeString = "";
	$CatTable = "";
	
	// Build header information
	$PageTitle = GetPageTitle(LANG_TTLCATSELECT);
	$CacheTag = "";
	
	// Send header
	include "inc/header.inc.php";
	
	// Open Database
	$DB = new SQLDatabase();
	$DB->dbconnect();
	if($DB==false)	{
		echo LANG_DBCONNECTERRORCUST;
		die();
	}
	
	// Do maintenance work
	if(!GetConfig('CRONJOB'))	{
		
		$iRand = (int)rand(1,(integer)GetConfig('MAINTAIN_PROBABILITY'));
		if($iRand==1)		{
		
			require_once("inc/maintain.inc.php");
			$oMaintain = new Maintain();
			
			if(GetConfig('AUTODELETEOUTDATED'))		{
				$oMaintain->DeleteOutdatedAds();
			}
			
			$oMaintain->DeleteInactiveUsers();
			$oMaintain->DeleteAlterPasswords();
			$oMaintain->UpdateCache();
		}
	}
	
	
	// Userdata
	// Indexpage
	if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']) 
		&& !empty($_SESSION['s_UserInfo']['userid']))		{
		
		$WelcomeString = ParseIn(LANG_INDEXUSERWELCOME, $_SESSION['s_UserInfo']['userrealname'],
			$_SESSION['s_UserInfo']['username'])."&nbsp;<br>".
			ParseIn(LANG_INDEXNEWARTICLES,AddSinceDate($_SESSION['s_UserInfo']['userlastlogin']));
	} else { 
		$WelcomeString = LANG_INDEXUSERUNKNOWN;
	}
	
	
	// Get user security
	if(GetConfig('SEC_HIDE_AGEREST_CATS') && GetConfig('SEC_FORCE_AGE_REST'))	{
		// Check user security
		if(isset($_SESSION['s_UserInfo']) && $_SESSION['s_UserInfo']['useragechecked'])	{
			// User checked ok
			$SecurityCheck = FALSE;
		} else {
			// User not authenticated or has proper rights
			$SecurityCheck = TRUE;	
		}
	} else {
		// Show all category entries
		$SecurityCheck = FALSE;	
	}


	// Reread Variables
	
	if(GetConfig('OP_SIMPLE_CATS'))		{

		$TotalArticles = ParseIn(LANG_SHOWADSARTICLECOUNT, GetArticlesInDB());
		
		// Read categories and sort them
		$sql = "SELECT * from cf_categories WHERE catprev IS NULL";
		
		switch(GetConfig('LY_SORT_ORDER_CATS'))	{
			case "2":
				// Sort by Name
				$sql.= " ORDER BY catname";
				break;
			case "3":
				// Sort by name descending
				$sql.= " ORDER BY catname DESC";
				break;
			default:
				// default sorter
				$sql.= " ORDER BY catid";
				break;
		}
			
		// Query database
		$data = $DB->dbselect($sql);
		if(!is_array($data))	{
			// No data or connection failed!
			echo LANG_DBEMPTYCATS;
			echo "<p><a href=\"admin.php\">".LANG_LINKTOADMINNOCATS."</a>";
			die();	
		}
			
		// Show categories
		$CatTable = "<div class=\"headline\">".
			LANG_HEADLINECATSELECT.
			"</div>".
			"<div class=\"subheadline\">".
			$TotalArticles.
			"</div>";

		$CatTable.= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"classad\">";
	
		// All categories loop
		foreach($data as $element)		{
			
			// Ageresticted cats should be hidden
			if(($element['catagerestricted']==1 && !$SecurityCheck) || 
				$element['catagerestricted']==0)	{
 				
				// Build some variables
				$strRestrictedPic = "<img src= \"".GetConfig('PD_SCRIPTGRAPHICS')."alert.gif\" ".
					"alt=\"".LANG_INDEXNEWARTICONAGE."\">";
				$strNewPic = "<img src= \"".GetConfig('PD_SCRIPTGRAPHICS')."new.gif\" ".
					"alt=\"".LANG_INDEXNEWARTICONNEW."\">";	
				
				// Get latest entry / last user visit
				$dtLatestIn = GetLatestArticlesPerCat($element['catid']);	
				$bNew = FALSE;	
				if(isset($_SESSION['s_UserInfo']['userlastlogin']))		{
					$bNew = ($dtLatestIn >= $_SESSION['s_UserInfo']['userlastlogin']?TRUE:FALSE);	
				}	
					
 				// Add logo
				$CatTable .= "<tr>".
					(!empty($element['caticonlink'])?"<td width=\"5%\" class=\"previewimage\">".
						"<img src=\"".GetConfig('PD_DIRCATLOGOS').$element['caticonlink']."\" ".
						"alt=\"".$element['catname']."\"></td>":"");
					

				// Add category title
				$CatTable.= "<td width=\"25%\" class=\"catblock\">".
					"<a href=\"showads.php?catid=".$element['catid']."\">".$element['catname']."</a>".
					"</td>";
				
				// Add category description
				$CatTable.= "<td width=\"60%\"class=\"catblock\">".
					(GetConfig('SEC_FORCE_AGE_REST') && $element['catagerestricted']==1?$strRestrictedPic:"").
					$element['catdesc'].
					"</td>";
				
				// Add category information
				$CatTable .= "<td width=\"15%\" class=\"catblock\" align=\"right\">".
					ParseIn(LANG_SHOWADSARTICLECOUNT,GetArticlesPerCat($element['catid'])).
					"<br>".($bNew?$strNewPic:"").FormatDate($dtLatestIn)."</td>".
					"</tr>";				
			}
		}
		$CatTable .= "</table>";
		
	} else {
		
		//
		// Build complex category overview
		//
		
		// Beachtet noch nicht Agestricted ***************************
		$oSCM = new SimpleCategoryManager(NULL);
		$CatArray = $oSCM->GetCategoryOverview();
		
		$TotalArticles = ParseIn(LANG_SHOWADSARTICLECOUNT, GetArticlesInDB());
		
		if(!is_array($CatArray) || sizeof($CatArray)==0)	{			
			// No category data or connection failed!
			echo LANG_DBEMPTYCATS;
			echo "<p><a href=\"admin.php\">".LANG_LINKTOADMINNOCATS."</a>";
			die();	
		}
					
		// Division of cats to columns	
		$CatsNo = $oSCM->GetLevel0CategoryCount();
		
		$PartArray=array();
		for($i=0;$i<GetConfig('OP_COMPLEX_CATS_COLS');$i++)	{
			$PartArray[$i] = ceil($CatsNo / (GetConfig('OP_COMPLEX_CATS_COLS')-$i));
			$CatsNo = $CatsNo - $PartArray[$i];
		}
		
		// Build display table
		$CatTable = "<div class=\"headline\">".
			LANG_HEADLINECATSELECT.
			"</div>".
			"<div class=\"subheadline\">".
			$TotalArticles.
			"</div>";
			
		$CatTable.= "<table width=\"99%\" cellspacing=\"0\" class=\"classad\">";
	
	
		// Build columns
		for($row=0;$row<$PartArray[0];$row++)	{				// Row counter
			
			$CatTable .= "<tr valign=\"top\">";
			// Cycle through columns and build main cat tables
			for($col=0;$col<sizeof($PartArray);$col++)		{	// Col counter
				
				if(GetConfig('OP_COMPLEX_CATS_BUILD_ORDER')=="1")	{
					$ArrayIndex = ($row * sizeof($PartArray))+ $col;
				} else { 
					$ArrayIndex = ($col * $PartArray[0]) + $row; 
				}

				$CatTable .= "<td class=\"catblock\" width=\"".sprintf("%0d",( 100 / sizeof($PartArray)))."%\">";
				if($ArrayIndex > (sizeof($CatArray)-1))	{
					// Create blind table cell
					$CatTable.= "<table width=\"100%\"></table></td>";
					
				} else {

					// Get category object
					$oCategory = $CatArray[$ArrayIndex]['ELEMENT'];
					$arrSubs = $CatArray[$ArrayIndex]['SUBCATS'];
					$iCatId = $oCategory->iId;
		
					// Mark categories as age restricted
					if(GetConfig('SEC_FORCE_AGE_REST') && GetConfig('SEC_HIDE_AGEREST_CATS') && 
						$oCategory->bAgeRestricted)	{
						$AgeRestIcon = "&nbsp;<img src= \"".GetConfig('PD_SCRIPTGRAPHICS').
							"alert.gif\" alt=\"".LANG_INDEXNEWARTICONAGE."\">";
					} else { 
						$AgeRestIcon=""; 
					}
					
					$CatTable .= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">".
						"<tr>";
					
					// Logoworkx
					$PicLink = "";

					if(empty($oCategory->strIcon))	
					{ 
						$PicLink = "<td rowspan=\"2\" valign=\"middle\" align=\"left\">".
							"&nbsp;</td>";
					} else {
						$PicLink = "<td rowspan=\"2\" valign=\"middle\" align=\"left\">".
							"<img src=\"".GetConfig('PD_DIRCATLOGOS').$oCategory->strIcon."\" alt=\"".$oCategory->strName."\">";	
						$CatTable .= $PicLink."</td>";
					}

					
					// Mark new categories as NEW!
					$LatestIn = $oCategory->dtLastInCum;
					
					$NewPic = "";	
					if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']))	{
						// Known user / logged in			
						if($LatestIn >= $_SESSION['s_UserInfo']['userlastlogin']) {
							$NewPic = "<img src= \"".GetConfig('PD_SCRIPTGRAPHICS')."new.gif\" alt=\"".
								LANG_INDEXNEWARTICONNEW."\">";	
						} 
					} 
					
					$CatTable .= "<td class=\"headlinecat\" width=\"85%\" valign=\"top\">".
						$AgeRestIcon." <a href=\"showads.php?catid=".$oCategory->iId."\">".
						$oCategory->strName."</a> ".
						"<nobr>(".ParseIn(LANG_SHOWADSARTICLECOUNT,($oCategory->iAdCountCum + $oCategory->iAdCount)).")".
						"</nobr>".$NewPic."</td></tr>".
						"<tr>".
						"<td width=\"85%\" align=\"center\">".
							BuildSubCatsFromArray($arrSubs,GetConfig('OP_COMPLEX_CATS_MAXSUB'),
							GetConfig('OP_COMPLEX_CATS_SUB_ART_COUNT'),$SecurityCheck).
						"</td>".
						"</tr>".
						"</table>".
						"</td>";
				}
			}
			$CatTable .= "</tr>\r\n";
		}
		$CatTable .= "</table>";
	}
	
	// Process featured article function
	if(GetConfig('OP_BUILD_FEATURED_ADS'))	{

		$FeaturedTable = "<div class=\"headline\">".
			LANG_HEADLINETTLFEATURED.
			"</div>";

		$FeaturedTable.= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\" class=\"classad\">".
			"<tr>".
			"<th width=\"7%\">".LANG_HEADLINEPICROW."</th>".
			"<th width=\"48%\">".LANG_HEADLINETITLEROW."</th>".
			"<th width=\"30%\">".LANG_HEADLINEWRITERROW."</th>".
			"<th width=\"10%\">".LANG_HEADLINEDATEROW."</th>".
			"<th width=\"5%\" align=\"right\">".LANG_HEADLINEADVIEWS."</th>".
			"</tr>";
	
		// Get featured ads from database
		$data = GetFeaturedArticles(GetConfig('OP_BUILD_FEATURED_NO_ADS'), TRUE, $SecurityCheck);

		if($data)	{
		
			$PrintLine=0;
			foreach($data as $element)		{
				
				$PrintLine++;
				$HighlightTag = ($PrintLine%2==0?"highlighted":"nonhighlighted");	
				
				// add thumbnails
				$ThumbPic="";
				if(!empty($element['adpiclink']))	{
					$ThumbPic = "<a href=\"showad.php?adid=".$element['adid']."\">".
						"<img src=\"".GetConfig('PD_USERGRAPHICS')."tn_".$element['adpiclink']."\" alt=\"".$element['adtitle']."\"></a>";
				} else {
					$ThumbPic = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."no_image.jpg\" ".
						"alt=\"".LANG_NOPICAVAILABLE."\">";	
				}
				if($element['adagerestricted']==true && GetConfig('SEC_FORCE_AGE_REST'))	{
					$AgeRestIcon = "<img src= \"".GetConfig('PD_SCRIPTGRAPHICS')."alert.gif\" ".
						"alt=\"".LANG_INDEXNEWARTICONADAGE."\"> ";
				} else { 
					$AgeRestIcon = ""; 
				}
						
				// add tabledata
				$FeaturedTable .= "<tr class=\"".$HighlightTag."\">".
					"<td width=\"7%\" class=\"previewimage\">".$ThumbPic."</td>".
					"<td width=\"48%\">".$AgeRestIcon." <a href=\"showad.php?adid=".$element['adid']."\">".$element['adtitle']."</a>".
						"<br><span class=\"smallsubtitle\">".DecodeAdType($element['adtype'])."</span></td>".
					"<td width=\"30%\">".$element['adname']."<br>(".(!empty($element['adzip'])? $element['adzip']." " : "").$element['adcity'].")".
					"</td>";
				
				// add a picture, if this ad was entered after users last visit
				$NewPic = "";
				
				if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']))	{
					
					// Known / logged in user
					if($element['adindate'] >= $_SESSION['s_UserInfo']['userlastlogin']) {
						$NewPic = "<img src= \"".GetConfig('PD_SCRIPTGRAPHICS')."new.gif\">";	
					} 
				} 
				
				$FeaturedTable .= "<td width=\"10%\">".FormatDate($element['adindate']).$NewPic."</td>".
					"<td width=\"5%\" align=\"right\">".$element['adviewed'].
					"</td></tr>";
			}
		
		} else {
				// No data or connection problems 
			$FeaturedTable .="<tr><td colspan=\"5\"><div align=\"center\">".LANG_NODATAENTRY."</div></td></tr>"; 
		}
		
		$FeaturedTable.= "</table>";
		
	} else {
		$FeaturedTable = "&nbsp;";
	}
	
	
	//
	// Latest in
	//	
	if(GetConfig('OP_BUILD_LATEST_ADS'))		{
		
		$data = GetLatestArticles(GetConfig('OP_BUILD_LATEST_NO_ADS'), $SecurityCheck);
		
		$LastInTable = "<div class=\"headline\">".
			LANG_HEADLINETTLLASTIN.
			"</div>";
								
		$LastInTable.= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\" class=\"classad\">".
			"<tr>".
			"<th width=\"7%\">".LANG_HEADLINEPICROW."</th>".
			"<th width=\"48%\">".LANG_HEADLINETITLEROW."</th>".
			"<th width=\"30%\">".LANG_HEADLINEWRITERROW."</th>".
			"<th width=\"10%\">".LANG_HEADLINEDATEROW."</th>".
			"<th width=\"5%\" align=\"right\">".LANG_HEADLINEADVIEWS."</th>".
			"</tr>";
	
		// Get featured ads from database
		if($data)	{
		
			$PrintLine=0;
			foreach($data as $element)		{
				
				$PrintLine++;
				$HighlightTag = ($PrintLine%2==0?"highlighted":"nonhighlighted");	
										
				// add thumbnails
				$ThumbPic="";
				if(!empty($element['adpiclink']))	{
					$ThumbPic = "<a href=\"showad.php?adid=".$element['adid']."\">".
						"<img src= \"".GetConfig('PD_USERGRAPHICS')."tn_".$element['adpiclink']."\" alt=\"".$element['adtitle']."\"></a>";
				} else {
					$ThumbPic = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."no_image.jpg\" alt=\"".LANG_NOPICAVAILABLE."\">";	
				}
				if($element['adagerestricted']==true && GetConfig('SEC_FORCE_AGE_REST'))	{
					$AgeRestIcon = "<img src= \"".GetConfig('PD_SCRIPTGRAPHICS')."alert.gif\" alt=\"".LANG_INDEXNEWARTICONADAGE."\"> ";
				} else { 
					$AgeRestIcon = ""; 
				}
						
				// add tabledata
				$LastInTable.= "<tr class=\"".$HighlightTag."\">".
					"<td width=\"7%\" class=\"previewimage\">".$ThumbPic."</td>".
					"<td width=\"48%\">".$AgeRestIcon." <a href=\"showad.php?adid=".$element['adid']."\">".$element['adtitle']."</a>".
						"<br><span class=\"smallsubtitle\">".DecodeAdType($element['adtype'])."</span></td>".
					"<td width=\"30%\">".$element['adname']."<br>(".(!empty($element['adzip'])? $element['adzip']." " : "").$element['adcity'].")".
					"</td>";
				
				$LastInTable.= "<td width=\"10%\">".FormatDate($element['adindate'])."</td>".
					"<td width=\"5%\" align=\"right\">".$element['adviewed']."</td></tr>";
			}
		
		} else {
				// No data or connection problems 
			$LastInTable.="<tr><td colspan=\"5\"><div align=\"center\">".LANG_NODATAENTRY."</div></td></tr>"; 
		}
		
		// Close surrounding table
		$LastInTable.= "</table>";
		
	} else {
		$LastInTable = "&nbsp;";
	}
	
	// Categorytemplate
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/index.tpl.php";
	include "inc/footer.inc.php";
	
?>		