<?php		

	/**
	 *	Display ad details
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	

	require "inc/includer.inc.php";
	require_once("inc/countries.inc.php");
	require_once("inc/picture.class.php");
	require_once("inc/picturelist.class.php");
	
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLSHOWAD);
	include "inc/header.inc.php";
	
	
	//
	// Init variables
	//
	$iAdID = -1;
	$strBreadCrumb = "";
	$FreeFieldCont = NULL;
	
	//
	// Get ad id
	//
	if(isset($_GET['adid']))	{
		$iAdID = (integer)$_GET['adid'];
	}
	
	if($iAdID<=0)	{
		// Hard redirect of user to index page
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=index.php\">";
 		include "inc/header.inc.php";
		die();
	} 
	

	// Read article from database - secure mode
	$data = GetArticleByID($iAdID, TRUE);
	if($data==false || sizeof($data)==0)	{	
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=index.php\">";
 		include "inc/header.inc.php";
		include "inc/footer.inc.php";
		die();	
	}
	$element = $data[0];

	
	// Securitycheck
	// Get category information first
	$CatArray = GetCategorieByID($element['adcat']);
	
	// Show restrictions in DEBUG-Mode
	if(GetConfig('DEBUG'))	{	
		echo "Cat restricted: ".($CatArray['catagerest']!="1" ? "not restricted":"restricted")."<br>";
		echo "Ad restricted: ".($element['adagerestricted']!="1" ? "not restricted":"restricted")."<br>";
		echo "Ad released: ".($element['adchecked']!="1" ? "not checked":"checked")."<br>";
	}
	
		
	// Check, if ad is released (only available for administrators)
	if($element['adchecked']!="1" 
		&& isset($_SESSION['s_UserInfo']) 
		&& !($_SESSION['s_UserInfo']['userrights'] & 64 ||
		$_SESSION['s_UserInfo']['userrights'] & 128))	{
		
		// Not allowed to view ad	
		echo LANG_ADVIEWNOTCHECKED;
		die();
	}
	
	// Check age restriction of ad and category
	if(GetConfig('SEC_FORCE_AGE_REST') && 
		($CatArray['catagerest']==1 || $element['adagerestricted']==1 ))	{
		
		// Yes, we have to check the age of user
		if(!isset($_SESSION['s_UserInfo']) || !is_array($_SESSION['s_UserInfo']) || 
			$_SESSION['s_UserInfo']['useragechecked']!=1)		{
			// Not allowed to view ad	
			echo LANG_ADVIEWNOTALLOWED;
			die();
		}
	}

	// Build ad history 
	if(!GetConfig('OP_SIMPLE_CATS'))	{
		$strBreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
			BuildCatHistory($CatArray['catprev']).
			" &gt; <a href=\"showads.php?catid=".$CatArray['catid']."\">".$CatArray['catname']."</a>".
			" &gt; ".$element['adtitle'];
	} else { 
		$strBreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
			"&nbsp;&gt;&nbsp;".
			"<a href=\"showads.php?catid=".$CatArray['catid']."\">".$CatArray['catname']."</a>".
			"&nbsp;&gt;&nbsp;".
			$element['adtitle'];
	}
	
	// Build free field definitions
	if(GetConfig('USE_FREE_FIELDS'))	{
		// Get free field definition and content
		$FreeFields = GetFreeFields($iAdID,false,false);	
		if(!$FreeFields==false)	{
			$FreeFieldCont = GetFreeFieldCont($FreeFields);			
		}
	}


	// Update Viewcounter
	AddCounter($iAdID, 1, 1);
	
	
	// Build variables
	
	//
	// Ad texts / pictures
	//
	$strAdTitle = $element['adtitle'];
	$strAdText = nl2br($element['adtext']);
	
	// Get ad picture list
	$strAdPictures = "";
	$strAdPictureCount = "";
	
	$oPicList = new PictureList();
	$oPicList->ReadList($iAdID);
	
	if(!is_null($oPicList) && $oPicList->Count()>0)	{
		
		$arrPics = $oPicList->GetPicArray();
		$strAdPictureCount = ($oPicList->Count()!=1?$oPicList->Count()." ".LANG_PICTURES:"1 ".LANG_PICTURE);
		
		// Ad has stored pictures
		if(GetConfig('LY_BIG_PICTURE_MODE'))		{
			
			$bHasPictures = FALSE;
			
			foreach($arrPics as $key=>$oPic)	{			
				if(!GetConfig('SEC_USE_PIC_RELEASE') || $oPic->bReleased)	{	
					$bHasPictures = TRUE;
					$strAdPictures.= "<div id=\"adpicturebig\">".
						"<img src=\"".GetConfig('PD_USERGRAPHICS').$oPic->strLink."\" alt=\"".$oPic->strTitle."\">".
						"</div>";
				} 
			}
			
			if(!$bHasPictures)	{
				$strAdPictures = "<i>".LANG_ADPICTURES_NOT_RELEASED."</i>";
			}
			
		} else {
			// Show thumbnails
			foreach($arrPics as $key=>$oPic)	{
				
				if(GetConfig('SEC_USE_PIC_RELEASE') && !$oPic->bReleased)	{
					
					// Display locked image
					$strLink = GetConfig('PD_SCRIPTGRAPHICS')."locked_image.jpg";
					$strAdPictures .= "<div id=\"adpicthumb\">".
						"<img src=\"".$strLink."\" alt=\"".LANG_PICTURE_NOT_RELEASED."\">".
						"</div>";
				} else {
									
					$strDesc = (empty($oPic->strTitle)?LANG_PICTURE_NO_DESCRIPTION:$oPic->strTitle);
					$strLink = GetConfig('PD_USERGRAPHICS')."tn_".$oPic->strLink;
	
					$strAdPictures .= "<div id=\"adpicthumb\">".
						"<a onClick=\"openPictureWin();\" ".
						"href=\"showadpictures.php?adid=".$oPic->iAdId."&pindex=".$key."\" target=\"detailPictures\">".				
						"<img src=\"".$strLink."\" alt=\"".$strDesc."\">".
						"</a>".
						"</div>";
				}		
			}
		}
		
	} else {
		$strAdThumbLink = GetConfig('PD_SCRIPTGRAPHICS')."no_image.jpg";
		$strAdPicture = LANG_SHOWADNOPICSATTACHED;
		$strAdPictureCount = "0 ".LANG_PICTURES; 
	}
	
	if(!empty($element['adpiclink']))		{
		$strAdThumbLink = GetConfig('PD_USERGRAPHICS')."tn_".$element['adpiclink'];
		$strAdPicture = "<img src=\"".GetConfig('PD_USERGRAPHICS').$element['adpiclink']."\">";
	} else {
		
	}
		
	//
	// Ad information
	//
	$strAdId = $element['adid'];
	$strAdViewCounter = $element['adviewed'];
	$strAdType = DecodeAdType($element['adtype']);
	$strAdInDate = FormatDate($element['adindate'],"",TRUE);
	$strAdInformation =	ParseIn(LANG_ADNOINFORMATION,$strAdId,$strAdInDate)." &middot; ".
		ParseIn(LANG_XTIMESVIEWED,$strAdViewCounter); 
	
	//
	// Freefields handling
	//	
	if(GetConfig('USE_FREE_FIELDS') && is_array($FreeFieldCont))	{	

		$strAdFreefieldText = "<table width=\"80%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
		
		foreach($FreeFieldCont as $arrFreefield)	{

			$strAdFreefieldText .= "<tr>".
				"<td width=\"40%\" class=\"formcelltitle\">".
				$arrFreefield['name'].
				"</td>".
				"<td width=\"60%\" class=\"formcellcontent\">".
				$arrFreefield['content'].
				"</td>".
				"</tr>";
		}
		
		$strAdFreefieldText.= "</table>";
		
	} else {
		$strAdFreefieldText = LANG_NOFREEFIELDINFORMATION;
	}
		
		
	//
	// Ad inserter
	//
	$strAdName = $element['adname'];
	$strAdZip = $element['adzip'];
	$strAdCity = $element['adcity'];
	$strAdCountry = $element['adcountry'];
	$strAdCountryFriendly = (array_key_exists($element['adcountry'],$GLOBALS['COUNTRIES'])?
		$GLOBALS['COUNTRIES'][$element['adcountry']]:"???");

	//
	// Ad communication
	//
	$strAdPhone = $element['adtel'];
	$strAdEmail = $element['ademail'];
	$strAdMobile = $element['admobile'];
	$strAdFax = $element['adfax'];
	$strAdHomepage = $element['adhomepage'];
	$strAdIcq = $element['adicq'];
	$strAdAim = $element['adaim'];
	$strAdYahoo = $element['adyahoo'];
	$strAdMsn = $element['admsn'];
	$strAdSkype = $element['adskype'];
	$strIcqStatus = "<img src=\"http://web.icq.com/whitepages/online?icq=".$strAdIcq."&img=5\">";
	
	$strAdCommunications = 
		(!empty($strAdPhone)?LANG_FIELDTEL.": ".$strAdPhone."<br>":"").
		(!empty($strAdMobile)?LANG_FIELDMOBILE.": ".$strAdMobile."<br>":"").
		(!empty($strAdFax)?LANG_FIELDTELFAX.": ".$strAdFax."<br>":"").
		(!empty($strAdHomepage)?LANG_FIELDHOMEPAGE.
			": <a href=\"http://".$strAdHomepage."\" target=\"blank\">".$strAdHomepage."</a><br>":"").
		(!empty($strAdIcq)?LANG_FIELDICQNO.": ".$strAdIcq."<br>":"").
		(!empty($strAdAim)?LANG_FIELDAIM.": ".$strAdAim."<br>":"").
		(!empty($strAdYahoo)?LANG_FIELDYAHOO.": ".$strAdYahoo."<br>":"").
		(!empty($strAdMsn)?LANG_FIELDMSN.": ".$strAdMsn."<br>":"").
		(!empty($strAdSkype)?LANG_FIELDSKYPE.": ".$strAdSkype."<br>":"");
		
	//
	// Actions
	//
	$strAdActionEdit = "";
	$strAdActionContact = "";
	$strAdActionTell = "";
	$strAdActionObserve = "";
		
	// Use internal mailer for chiffre answers or display email
	if(!GetConfig('ML_RESPONDVIAEMAIL'))	{
		$strAdActionContact = "<a href=\"contactad.php?adid=".$strAdId."\">".LANG_GETINCONTACT."</a>";
	} else {
		$strAdActionContact = "<a href=\"mailto:".$strAdEmail."\">".$strAdEmail."</a>";
	}
	
	$strAdActionTell = "<a href=\"tellad.php?adid=".$strAdId."\">".LANG_LINKTOTELLLINK."</a>";	
	
	// If this ad was entered by active user - show edit link
	if(isset($_SESSION['s_UserInfo']['userid']) 
		&& ($_SESSION['s_UserInfo']['userid'] == $element['aduserid']))	{
		
		$strAdActionEdit = 	"<a href=\"editmessageuser.php?adid=".$element['adid'].
			"\">".LANG_LINKTOEDITMYAD."</a>";
	}
	
	$strActionList = "<li>".$strAdActionContact."</li>".
		"<li>".$strAdActionTell."</li>".
		(!empty($strAdActionObserve)?"<li>".$strAdActionObserve."</li>":"").
		(!empty($strAdActionEdit)?"<li>".$strAdActionEdit."</li>":"");
	
		
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/showad.tpl.php";
	include "inc/footer.inc.php";
	
?>
 